/***********************************************************************
 * Module:  CBlocOptiqueArriere.cpp
 * Author:  clems
 * Modified: mercredi 19 janvier 2005 16:14:07
 * Purpose: Implementation of the class CBlocOptiqueArriere
 ***********************************************************************/

#include "CBlocOptiqueArriere.h"

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptiqueArriere::AllumerVeilleuse()
// Purpose:    Implementation of CBlocOptiqueArriere::AllumerVeilleuse()
// Return:     void 
////////////////////////////////////////////////////////////////////////

void CBlocOptiqueArriere::AllumerVeilleuse(void)
{
   CBlocOptique::AllumerSortie1();
}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptiqueArriere::EteindreVeilleuse()
// Purpose:    Implementation of CBlocOptiqueArriere::EteindreVeilleuse()
// Return:     void 
////////////////////////////////////////////////////////////////////////

void CBlocOptiqueArriere::EteindreVeilleuse(void)
{
   CBlocOptique::EteindreSortie1();

}


////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptiqueArriere::AllumerStop()
// Purpose:    Implementation of CBlocOptiqueArriere::AllumerStop()
// Return:     void
////////////////////////////////////////////////////////////////////////

void CBlocOptiqueArriere::AllumerStop(void)
{
  CBlocOptique::AllumerSortie2();


}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptiqueArriere::EteindreStop()
// Purpose:    Implementation of CBlocOptiqueArriere::EteindreStop()
// Return:     void
////////////////////////////////////////////////////////////////////////

void CBlocOptiqueArriere::EteindreStop(void)
{
 CBlocOptique::EteindreSortie2();

}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptiqueArriere::AllumerClignotant()
// Purpose:    Implementation of CBlocOptiqueArriere::AllumerClignotant()
// Return:     void 
////////////////////////////////////////////////////////////////////////

void CBlocOptiqueArriere::AllumerClignotant(void)
{      
  CBlocOptique::AllumerSortie3();

}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptiqueArriere::EteindreClignotant()
// Purpose:    Implementation of CBlocOptiqueArriere::EteindreClignotant()
// Return:     void 
////////////////////////////////////////////////////////////////////////

void CBlocOptiqueArriere::EteindreClignotant(void)
{
 CBlocOptique::EteindreSortie3();

}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptiqueArriere::AllumerKlaxon()
// Purpose:    Implementation of CBlocOptiqueArriere::AllumerKlaxon()
// Return:     void 
////////////////////////////////////////////////////////////////////////

void CBlocOptiqueArriere::AllumerKlaxon(void)
{      
  CBlocOptique::AllumerSortie4();

}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptiqueArriere::EteindreKlaxon()
// Purpose:    Implementation of CBlocOptiqueArriere::EteindreKlaxon()
// Return:     void 
////////////////////////////////////////////////////////////////////////

void CBlocOptiqueArriere::EteindreKlaxon(void)
{
 CBlocOptique::EteindreSortie4();

}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptiqueArriere::TestVeilleuse()
// Purpose:    Implementation of CBlocOptiqueArriere::TestVeilleuse()
// Return:     bool 
////////////////////////////////////////////////////////////////////////

bool CBlocOptiqueArriere::TestVeilleuse(void)
{      
  return(CBlocOptique::EtatSortie1());

}
////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptiqueArriere::TestStop()
// Purpose:    Implementation of CBlocOptiqueArriere::TestStop()
// Return:     bool 
////////////////////////////////////////////////////////////////////////

bool CBlocOptiqueArriere::TestStop(void)
{      
  return(CBlocOptique::EtatSortie2());

}
////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptiqueArriere::Clignotant()
// Purpose:    Implementation of CBlocOptiqueArriere::Clignotant()
// Return:     bool 
////////////////////////////////////////////////////////////////////////

bool CBlocOptiqueArriere::TestClignotant(void)
{      
  return(CBlocOptique::EtatSortie3());

}
////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptiqueArriere::TestKlaxon()
// Purpose:    Implementation of CBlocOptiqueArriere::TestKlaxon()
// Return:     bool 
////////////////////////////////////////////////////////////////////////

bool CBlocOptiqueArriere::TestKlaxon(void)
{      
  return(CBlocOptique::EtatSortie4());

}


 


////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptiqueArriere::CBlocOptiqueArriere()
// Purpose:    Implementation of CBlocOptiqueArriere::CBlocOptiqueArriere()
// parametre : 	addr adresse RXF1 du blocOPtique
//			ctrlcan adresse du controleur can grant
// Return:     void
////////////////////////////////////////////////////////////////////////
CBlocOptiqueArriere::CBlocOptiqueArriere(int Addr , CControleurCan* ctrlcan):CBlocOptique(Addr ,ctrlcan)
{

}