/***********************************************************************
 * Module:  CBlocOptiqueArriere.h
 * Author:  clems
 * Modified: mercredi 19 janvier 2005 16:14:07
 * Purpose: Declaration of the class CBlocOptiqueArriere
 ***********************************************************************/

#if !defined(__Globale_CBlocOptiqueArriere_h)
#define __Globale_CBlocOptiqueArriere_h

#include "CBlocOptique.h"

class CBlocOptiqueArriere : public CBlocOptique
{
public:
   void AllumerVeilleuse(void);
   void EteindreVeilleuse(void);
   void AllumerStop(void);
   void EteindreStop(void);
   void AllumerClignotant(void);
   void EteindreClignotant(void);
   void AllumerKlaxon(void);
   void EteindreKlaxon(void);
   bool TestVeilleuse(void);
   bool TestStop(void);
   bool TestClignotant(void);
   bool TestKlaxon(void);

CBlocOptiqueArriere(int Addr , CControleurCan* ctrlcan);

protected:
private:

};

#endif