/***********************************************************************
 * Module:  CBlocOptiqueAvant.cpp
 * Author:  clems
 * Modified: mercredi 19 janvier 2005 11:38:21
 * Purpose: Implementation of the class CBlocOptiqueAvant
 ***********************************************************************/

#include "CBlocOptiqueAvant.h"

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptiqueAvant::AllumerClignotant()
// Purpose:    Implementation of CBlocOptiqueAvant::AllumerClignotant()
// Return:     void
////////////////////////////////////////////////////////////////////////

void CBlocOptiqueAvant::AllumerClignotant(void)
{
   CBlocOptique::AllumerSortie4();

}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptiqueAvant::AllumerVeilleuse()
// Purpose:    Implementation of CBlocOptiqueAvant::AllumerVeilleuse()
// Return:     void
////////////////////////////////////////////////////////////////////////

void CBlocOptiqueAvant::AllumerVeilleuse(void)
{

   CBlocOptique::AllumerSortie1();
}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptiqueAvant::AllumerCode()
// Purpose:    Implementation of CBlocOptiqueAvant::AllumerCode()
// Return:     void
////////////////////////////////////////////////////////////////////////

void CBlocOptiqueAvant::AllumerCode(void)
{
   CBlocOptique::AllumerSortie2();
CBlocOptique::EteindreSortie3();	
}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptiqueAvant::AllumerPhare()
// Purpose:    Implementation of CBlocOptiqueAvant::AllumerPhare()
// Return:     void
////////////////////////////////////////////////////////////////////////

void CBlocOptiqueAvant::AllumerPhare(void)
{
	CBlocOptique::AllumerSortie3();
	 CBlocOptique::EteindreSortie2();

}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptiqueAvant::EteindreCode()
// Purpose:    Implementation of CBlocOptiqueAvant::EteindreCode()
// Return:     void 
////////////////////////////////////////////////////////////////////////

void CBlocOptiqueAvant::EteindreCode(void)
{
   CBlocOptique::EteindreSortie2();

}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptiqueAvant::EteindreVeilleuse()
// Purpose:    Implementation of CBlocOptiqueAvant::EteindreVeilleuse()
// Return:     void 
////////////////////////////////////////////////////////////////////////

void CBlocOptiqueAvant::EteindreVeilleuse(void)
{
   CBlocOptique::EteindreSortie1();
}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptiqueAvant::EteindrePhare()
// Purpose:    Implementation of CBlocOptiqueAvant::EteindrePhare()
// Return:     void 
////////////////////////////////////////////////////////////////////////

void CBlocOptiqueAvant::EteindrePhare(void)
{
CBlocOptique::EteindreSortie3();
}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptiqueAvant::EteindreClignotant()
// Purpose:    Implementation of CBlocOptiqueAvant::EteindreClignotant()
// Return:     void 
////////////////////////////////////////////////////////////////////////

void CBlocOptiqueAvant::EteindreClignotant(void)
{
CBlocOptique::EteindreSortie4();
}


////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptiqueArriere::TestVeilleuse()
// Purpose:    Implementation of CBlocOptiqueArriere::TestVeilleuse()
// Return:     bool 
////////////////////////////////////////////////////////////////////////

bool CBlocOptiqueAvant::TestVeilleuse(void)
{      
  return(CBlocOptique::EtatSortie1());

}
////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptiqueArriere::TestCode()
// Purpose:    Implementation of CBlocOptiqueArriere::TestCode()
// Return:     bool 
////////////////////////////////////////////////////////////////////////

bool CBlocOptiqueAvant::TestCode(void)
{      
  return(CBlocOptique::EtatSortie2());

}
////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptiqueArriere::TestPhare()
// Purpose:    Implementation of CBlocOptiqueArriere::TestPhare()
// Return:     bool 
////////////////////////////////////////////////////////////////////////

bool CBlocOptiqueAvant::TestPhare(void)
{      
  return(CBlocOptique::EtatSortie3());

}
////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptiqueArriere::Clignotant()
// Purpose:    Implementation of CBlocOptiqueArriere::Clignotant()
// Return:     bool 
////////////////////////////////////////////////////////////////////////

bool CBlocOptiqueAvant::TestClignotant(void)
{      
  return(CBlocOptique::EtatSortie4());

}



////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptiqueAvant::CBlocOptiqueAvant()
// Purpose:    Implementation of CBlocOptiqueArriere::CBlocOptiqueArriere()
// parametre : 	addr adresse RXF1 du blocOPtique
//			ctrlcan adresse du controleur can grant
// Return:     void
////////////////////////////////////////////////////////////////////////
CBlocOptiqueAvant::CBlocOptiqueAvant(int Addr , CControleurCan* ctrlcan):CBlocOptique(Addr ,ctrlcan)
{

}
