/***********************************************************************
 * Module:  CBlocOptiqueAvant.h
 * Author:  clems
 * Modified: mercredi 19 janvier 2005 11:38:21
 * Purpose: Declaration of the class CBlocOptiqueAvant
 ***********************************************************************/

#if !defined(__Globale_CBlocOptiqueAvant_h)
#define __Globale_CBlocOptiqueAvant_h

#include "CBlocOptique.h"

class CBlocOptiqueAvant : public CBlocOptique
{
public:
   void AllumerClignotant(void);
   void AllumerVeilleuse(void);
   void AllumerCode(void);
   void AllumerPhare(void);
   void EteindreCode(void);
   void EteindreVeilleuse(void);
   void EteindrePhare(void);
   void EteindreClignotant(void);

   bool TestVeilleuse(void);
   bool TestCode(void);
   bool TestClignotant(void);
   bool TestPhare(void);

CBlocOptiqueAvant(int Addr , CControleurCan* ctrlcan);
protected:
private:

};

#endif