#include "Structures_Donnees.h"
#include "cpu_reg.h"
#include "eid210_reg.h"
#include "Can_vmd.h"
#include "CControleurCan.h"
#include <stdio.h>
#include "CAnalyseurCan.h"

extern "C" {
void Init_Aton_CAN();
void Stop_Aton_CAN();
char Ecrire_Trame(Trame message);
char Lire_Trame(Trame *message_recu);
void Affiche_Trame(Trame trame);
void gotoxy(char,char);
};

CControleurCan::CControleurCan(CAnalyseurCan * analyseur_can)
{
/* Initialisation DU SJA1000 de la carte ATON-Systemes" sur  */
Init_Aton_CAN();
analyseurCan=analyseur_can;
}

CControleurCan::~CControleurCan()
{
Stop_Aton_CAN();
}

void CControleurCan::EcrireTrame(CTrame trame)
{
CTrame tr_ACK;
int cpt=0;
//envoie trame
Ecrire_Trame(trame.LitTrame());

if(analyseActive==true)
{
	analyseurCan->AfficherTrameEnvoyee(trame);
}

//attente ACK
/*while(LireTrame(tr_ACK)!=true&&cpt<2000)
{
gotoxy(1,2);
printf("cpt = %d\n",cpt);
cpt++;
};*/

}

bool CControleurCan::LireTrame(CTrame& trame1)
{
bool envoi=false;
Trame trame;


if(Lire_Trame(&trame)==1)
{

trame1.SetAdresse(trame.ident.extend.identificateur.ident);
trame1.SetDonnee((unsigned char *)trame.data,trame.trame_info.champ.dlc);
	envoi=true;
	if(analyseActive==true)
	{
	analyseurCan->AfficherTrameRecue(trame1);
	}
}
else
{
	envoi=false;
}


return envoi;
}

Trame CControleurCan::LitTrame()
{
Trame trame;

return trame;
}

CControleurCan::ActiveAnalyse(bool activation)
{
analyseActive=activation;//true->active l'analiseur de trave ou false-<desactive
}

