/***********************************************************************
 * Module:  CTrame.cpp
 * Author:  clems
 * Modified: jeudi 20 janvier 2005 10:14:19
 * Purpose: Implementation of the class CTrame
 ***********************************************************************/

#include "PeripheriquesCAN.h"
#include "Structures_Donnees.h"
#include "cpu_reg.h"
#include "eid210_reg.h"
//#include "Can_vmd.h"

#include "CTrame.h"

////////////////////////////////////////////////////////////////////////
// Name:       CTrame::SetRegistre(unsigned char registre, int bit)
// Purpose:    Implementation of CTrame::SetRegistre()
// Parameters:
// - registre
// - bit
// Return:     int
////////////////////////////////////////////////////////////////////////

int CTrame::SetRegistre(unsigned char registre, int bit)
{
   // TODO : implement
   //TrameC.trame_info.registre=registre;

}

////////////////////////////////////////////////////////////////////////
// Name:       CTrame::SetEtendu(bool etendu)
// Purpose:    Implementation of CTrame::SetEtendu()
// Comment:    Active le mode Etendu du bus can
// Parameters:
// - etendu
// Return:     int
////////////////////////////////////////////////////////////////////////

int CTrame::SetEtendu(bool etendu)
{
   // TODO : implement
   if(etendu==true)
   {
   TrameC.trame_info.champ.extend=1;
   }
   else
   {
   TrameC.trame_info.champ.extend=0;
   }
}

////////////////////////////////////////////////////////////////////////
// Name:       CTrame::SetDlc(char dlc)
// Purpose:    Implementation of CTrame::SetDlc()
// Parameters:
// - dlc
// Return:     int
////////////////////////////////////////////////////////////////////////

int CTrame::SetDlc(char dlc)
{
   // TODO : implement
   TrameC.trame_info.champ.dlc=dlc; 
}

////////////////////////////////////////////////////////////////////////
// Name:       CTrame::SetIdent(long identificateur)
// Purpose:    Implementation of CTrame::SetIdent()
// Parameters:
// - identificateur
// Return:     int
////////////////////////////////////////////////////////////////////////

int CTrame::SetIdent(long identificateur)
{
   // TODO : implement
   TrameC.ident.extend.identificateur.ident=Ident_T_IM_FRD; // C'est l'identificateur du bloc optique arrire droit
	 // Pour recevoir une commande (IM "Input Message")  dfinie dans fichier CAN_VMD.h

}

////////////////////////////////////////////////////////////////////////
// Name:       CTrame::SetData(char * TData)
// Purpose:    Implementation of CTrame::SetData()
// Parameters:
// - TData
// Return:     int
////////////////////////////////////////////////////////////////////////

int CTrame::SetData(char * TData)
{
   // TODO : implement
TrameC.data[0]=*TData;	// premire donne -> "Adresse" du registre concerne 
TrameC.data[1]=*(TData+1);	// deuxime donne -> "Masque" -> les sorties sont sur les 4 bits de poids faibles
TrameC.data[2]=*(TData+2);	// troisime donne -> "Valeur" -> au dpart toutes les sorties sont  0 (lampes teintes)

}

////////////////////////////////////////////////////////////////////////
// Name:       CTrame::GetRegistre()
// Purpose:    Implementation of CTrame::GetRegistre()
// Return:     int
////////////////////////////////////////////////////////////////////////

int CTrame::GetRegistre(void)
{
   // TODO : implement
   return  TrameC.trame_info.registre;
}

////////////////////////////////////////////////////////////////////////
// Name:       CTrame::GetEtendu()
// Purpose:    Implementation of CTrame::GetEtendu()
// Return:     int
////////////////////////////////////////////////////////////////////////

int CTrame::GetEtendu(void)
{
   // TODO : implement
    return TrameC.trame_info.champ.extend;
}

////////////////////////////////////////////////////////////////////////
// Name:       CTrame::GetDlc()
// Purpose:    Implementation of CTrame::GetDlc()
// Return:     int
////////////////////////////////////////////////////////////////////////

int CTrame::GetDlc(void)
{
   // TODO : implement
   return TrameC.trame_info.champ.dlc;
}

////////////////////////////////////////////////////////////////////////
// Name:       CTrame::GetData(char * TData)
// Purpose:    Implementation of CTrame::GetData()
// Parameters:
// - TData
// Return:     int
////////////////////////////////////////////////////////////////////////

int CTrame::GetData(char * TData)
{
   // TODO : implement
}

////////////////////////////////////////////////////////////////////////
// Name:       CTrame::GetIdent()
// Purpose:    Implementation of CTrame::GetIdent()
// Return:     int
////////////////////////////////////////////////////////////////////////

int CTrame::GetIdent(void)
{
   // TODO : implement
   return TrameC.ident.extend.identificateur.ident;
}

////////////////////////////////////////////////////////////////////////
// Name:       CTrame::CTrame()
// Purpose:    Implementation of CTrame::CTrame()
// Comment:    Constructeur par defaut
// Return:     int
////////////////////////////////////////////////////////////////////////

CTrame::CTrame()
{
//constructeur
TrameC.trame_info.registre=0x00;
TrameC.trame_info.champ.extend=1; // On travaille en mode tendu
TrameC.trame_info.champ.dlc=0x03; // Il y aura 3 donnes de 8 bits (3 octets envoys)

}

////////////////////////////////////////////////////////////////////////
// Name:       CTrame::GetTrame()
// Purpose:    Implementation of CTrame::GetTrame()
// Return:     Trame *
////////////////////////////////////////////////////////////////////////

Trame * CTrame::GetTrame(void)
{
   // TODO : implement
   //retourne l'adresse de la trame C
   return &TrameC;
}

////////////////////////////////////////////////////////////////////////
// Name:       CTrame::SetRtr()
// Purpose:    Implementation of CTrame::SetRtr()
// Return:     int
////////////////////////////////////////////////////////////////////////

int CTrame::SetRtr(void)
{
   // TODO : implement
   //...
}

////////////////////////////////////////////////////////////////////////
// Name:       CTrame::GetRtr()
// Purpose:    Implementation of CTrame::GetRtr()
// Return:     int
////////////////////////////////////////////////////////////////////////

int CTrame::GetRtr(void)
{
   // TODO : implement
}