/***********************************************************************
 * Module:  CBlocOptique.h
 * Author:  clems
 * Modified: vendredi 21 janvier 2005 14:50:45
 * Purpose: Declaration of the class CBlocOptique
 ***********************************************************************/

#if !defined(__Globale_CBlocOptique_h)
#define __Globale_CBlocOptique_h

#include "PeripheriqueCAN_Sortie.h"
#include "CControleurCan.h"

class CBlocOptique : public PeripheriqueCAN_Sortie
{
public:
   CTrame AllumerVeilleuse(void);
   CTrame AllumerCode(void);
   CTrame AllumerPhare(void);
   CTrame EteindreCode(void);
   CTrame EteindreVeilleuse(void);
   CTrame EteindrePhare(void);
   CTrame AllumerStop(void);
   CTrame EteindreStop(void);
   CTrame AllumerClignotant(void);
   CTrame EteindreClignotant(void);
   CBlocOptique(int,CControleurCan*);

   

protected:
private:

};

#endif