
#include "Structures_Donnees.h"
#include "cpu_reg.h"
#include "eid210_reg.h"
//#include "Can_vmd.h"

#include "CTrame.h"
#include <stdio.h>

CTrame::CTrame()
{
trame.trame_info.registre=0x00;
trame.trame_info.champ.extend=1; // On travaille en mode tendu
trame.trame_info.champ.dlc=0x00;
trame.ident.extend.identificateur.ident=0;
}

CTrame::CTrame(int adr)
{
trame.trame_info.registre=0x00;
trame.trame_info.champ.extend=1; // On travaille en mode tendu
trame.trame_info.champ.dlc=0x00;
trame.ident.extend.identificateur.ident=adr;
}


CTrame::~CTrame()
{
}

void CTrame::SetAdresse(int adr)
{
trame.ident.extend.identificateur.ident=adr;
}

int CTrame::GetAdresse()
{
int adr;
adr=trame.ident.extend.identificateur.ident;
return adr;
}

void CTrame::SetDonnee(char *data,int l)
{
int i;
trame.trame_info.champ.dlc=l;
for(i=0;i<l;i++)
	{
	trame.data[i]=data[i];
	}
}

void CTrame::GetDonnee(char *data,int * l)
{
int i;
*l=trame.trame_info.champ.dlc;
for(i=0;i<*l;i++)
	{
	data[i]=trame.data[i];
	}
}

Trame CTrame::LitTrame()
{
return trame;
}
