/***********************************************************************
 * Module:  PeripheriquesCAN.h
 * Author:  clems
 * Modified: lundi 24 janvier 2005 15:02:56
 * Purpose: Declaration of the class PeripheriquesCAN
 ***********************************************************************/

#if !defined(__Globale_PeripheriquesCAN_h)
#define __Globale_PeripheriquesCAN_h

class CTrame;

#include "Peripheriques.h"
#include "CControleurCan.h"

class PeripheriquesCAN : public Peripheriques
{
public:
   int DecoderTrame(void);
   int ConstruireTrame(void);
   int EnvoyerEtat(void);
   int RecevoirEtat(void);
   PeripheriquesCAN(int Addr, CControleurCan* ctrlcan);

   CControleurCan * ctrl_can;
   
   CTrame* Communique_Avec;

protected:
   int Adresse;
   char Data[20];
   short priorite;
   short noeud;
   short type_message;
   Trame trame;

private:

};

#endif