	/*************************************************************************
	*     TP sur  EID210 avec SIMULATEUR D'ENTREES SORTIES	*
	*************************************************************************
	*  	Test du port C qui pilote l'afficheur 7 segments		* 
	*        	 pour afficher un nombre dcimal  ( 0  9)			*			
	*  CAHIER DES CHARGES  :					      	*
	******************************					      	*	
	*  L'afficheur affiche un nombre dcimal (entre 0 et 9)		*
	*  qui s'incrmente environ toutes les secondes 			*
	*  Ce temps sera gnr par une boucle "logiciel"		      	*
	*-------------------------------------------------------------------------------------------------------	*
	*  NOM du FICHIER:  Aff_7S_D.C			       		*
	**********************							*
	*************************************************************************/

#include "EID210_reg.h"
#include "Simulateur_ES.h"
#include "Structures_donnees.h"

//*********************
//  DECLARATIONS  
//*********************

// Les prototypes des fonctions
void AFFICHER(unsigned char);
void ATTENDRE(unsigned char);
//============================
//   	FONCTION PRINCIPALE 
//============================
main()
{
//Varirables locales
//********************
unsigned char compteur;

//  Initialisations
//*****************

Dir_Port_C=0xFF;	// Les 8 bits MSB sont valides
Port_C=0x00;

//Dbut de la boucle principale
//*********************************
	do
	{
		for (compteur=0;compteur<=9;compteur++)
		{
			//Appeler la fonction AFFICHER
			AFFICHER(compteur);
			//Appeler la fonction ATTENDRE
			ATTENDRE(1);
		}
	  /*Remise  0 du compteur */
	  compteur=0;
	 }while (1);
}
//Fin de la fonction principale
//********************************


//*********************************
//	FONCTION AFFICHER 
//*********************************
void AFFICHER(unsigned char chiffre)
{switch(chiffre)
	{
	case 0 : PortC=AFF_0;break;
	case 1 : PortC=AFF_1;break;
	case 2 : PortC=AFF_2;break;
	case 3 : PortC=AFF_3;break;
	case 4 : PortC=AFF_4;break;
	case 5 : PortC=AFF_5;break;
	case 6 : PortC=AFF_6;break;
	case 7 : PortC=AFF_7;break;
	case 8 : PortC=AFF_8;break;
	case 9 : PortC=AFF_9;break;
	case 10 : PortC=AFF_10;break;
	case 11 : PortC=AFF_11;break;
	case 12 : PortC=AFF_12;break;
	case 13 : PortC=AFF_13;break;
	case 14 : PortC=AFF_14;break;
	case 15 : PortC=AFF_15;break;
	}
}

//=============================
//	FONCTION  ATTENDRE 
//=============================
void ATTENDRE(unsigned char nb)
{int i;	
	for(i=300000*nb;i>0;i--);	/* Dcrmentation de la variable de temporisation */
}
