
	/*************************************************************************
	*     TP sur  EID210 avec SIMULATEUR D'ENTREES SORTIES	*
	*************************************************************************
	*	 Affichage sur 7 segments de l'entre analogique		*
	*  	 n 0 (celle du potentiomtre)					*
	*								      	*	
	*  Cahier des charges:					      	*
	*   **********************					      	*	
	*  On affiche un nombre hexadcimal (entre 0 et 15)			*
	*  qui correspond aux poids forts du rsultat de conversion		*
	*  de l'entre analogique E0  						*
	*  (impose par la position du potentiomtre)			*
	* ---------------------------------------------------------------------------------------------------
	*  NOM du FICHIER:  CAN_Port_C.C			       		*
	* ********************							*
	*************************************************************************/
/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Simulateur_ES.h"
#include "Structures_donnees.h"

//****************************************
//	FONCTION PRINCIPALE 	
//****************************************

main()
{
int tmp;
short Cons_Mot=0;
short P_M;
CFSR3=0x8888;	/*  CHA0  CHA3 en mode "DIO" 	*/
CFSR2=0x8888;	/*  CHA4  CHA7 en mode "DIO"	*/
CFSR1=0x8888;	/*  CHA8  CHA11 en mode "DIO"	*/
CFSR0=0x8888;	/*  CHA12  CHA15 en mode "DIO"	*/
CPR1=0xFFFF;	/* Tous les bits de PA en priorit haute  */
CPR0=0xFFFF;	/* Tous les bits de PB en priorit haute  */
HSRR0=0x0900;
SA0=0;
Cons_Mot=0x70;
P_M=0;
 do
    {
	for(tmp=0;tmp<50000;tmp++);
	CAN=0x0050;
	do{printf("att\n");}while(CTRL&0x4000!=0x4000);
	printf("GO\n");
	if (P_M==0) Cons_Mot=Cons_Mot++;
	if (P_M==1) Cons_Mot=Cons_Mot--;
	SA0=Cons_Mot;
	if(Cons_Mot>0xA0  || Cons_Mot<0x70) 
		{
			if (P_M==0) P_M=1;
				else P_M=0;
		printf("Changement de sens\n");
		for(tmp=0;tmp<1000;tmp++);
		}
    }while(1);
}
