/*************************************************************************/
/*	But du Programme:									  */
/* Cration d'un chat sur le port telnet 						  */
/*************************************************************************/
#include "eid210.h"
#include "qsm.h"

#include "eid003.h"
#include "eid003_TCPIP.c"

//------------------------------------- Fonction principale
main()
{
	int carac,i;
	char ligrec = 18,colrec = 1,ligemi = 3,colemi = 1;
	clsscr();

	/*Configuration de la liaison serie 57600Bauds en emission + reception*/
	SCCR0 = 9;		// Pour la vitesse de transmission de 57600 bauds
	SCCR1 = 0x000C;	// Pour valider l'mission et la rception

	//Initialisation des temps d'accs pour la carte EID210
	Init_pc104_eid003();

	//Modification ventuelle de l'adresse de la carte
	printf("L'adresse de base de la carte est, par defaut, 10.0.0.24\n");
	printf("pour la modifier en 10.0.0.25, appuyer sur Y\n");
	carac=InRs232();
	if(carac=='Y' | carac=='y') config_tcp(0x0a000019,0xFFFFFF00);
		else config_tcp(0x0A000018,0xFFFFFF00);
	for(i=0;i<100000;i++);
	clsscr();
	//Affichage de l'adresse et du masque de la carte
	carac=Lit_tcp_adr();
	printf("Adresse de la carte : %x \n",carac);
	carac=Lit_tcp_mask();
	printf("Masque de sous rseau de la carte : %x \n",carac);
	for(i=0;i<100000;i++);

	//Configuration + ouverture du port TPC/IP TELNET
	SetPort(23);
	EID003_CONFIG=0x01;

	//Information de fonctionnement
	puts("Appuyer sur une touche pour continuer ...");
	puts("Appuyer $ pour quitter le programme   ...");
	InRs232();

	//Affichage graphique personnalise
	clsscr();
	for(i=0;i<50;i++)
	{
		gotoxy(i,15);
		puts("-");
	}
	gotoxy(0,0);
	puts("Fenetre d'emission :");
	puts("--------------------");
	gotoxy(0,16);
	puts("Fenetre de reception :");
	puts("----------------------");

//Boucle principale
while(carac!='$')
	{
	if(SCSR&RDRF)	//Si appuie touche
		{
		carac=SCDR;	//On rcupre le caractre
		EID003_BUFFER=carac;	//On le place dans le buffer d'mission
		EID003_CONFIG = 0x03;	//On l'envoi
		while((EID003_STATUS&0x04)==0x04); //On attend la fin de l'mission
		
		//Mise en page sur le moniteur
		gotoxy(colemi,ligemi);
		printf("%c\n",carac);
		puts("                                   ");
		colemi++;
		if(colemi==35)	//Nbs de caractres par ligne
			{
			ligemi++;
			colemi=1;
			}
		if(ligemi==14)	//Nbs de lignes
			{
			colemi=1;
			ligemi=3;
			}
		}

	if(EID003_RX_COUNT!=0)	//Si on reoit un caractre
		{
		carac=EID003_BUFFER; //On le recupre

		//Mise en page sur le moniteur
		gotoxy(colrec,ligrec);
		printf("%c\n",carac);
		puts("                                   ");
		colrec++;
		if(colrec==35)	//Nbs de caractres par ligne
			{
			ligrec++;
			colrec=1;
			}
		if(ligrec==32)	//Nbs de lignes
			{
			colrec=1;
			ligrec=18;
			}
		}
	}
SetPort(0);		// fermeture du port
EID003_CONFIG=0x01;
}