/* module sur la carte reseau eid003 */

#include "eid003.h"


void config_tcp(int tcp_adr,int tcp_mask)
{
EID003_adr.adr4=(unsigned char)(tcp_adr&0x000000FF);
EID003_adr.adr3=(unsigned char)((tcp_adr&0x0000FF00)>>8);
EID003_adr.adr2=(unsigned char)((tcp_adr&0x00FF0000)>>16);
EID003_adr.adr1=(unsigned char)((tcp_adr&0xFF000000)>>24);

EID003_mask.adr4=(unsigned char)(tcp_mask&0x000000FF);	/* configuration du mask */
EID003_mask.adr3=(unsigned char)((tcp_mask&0x0000FF00)>>8);
EID003_mask.adr2=(unsigned char)((tcp_mask&0x00FF0000)>>16);
EID003_mask.adr1=(unsigned char)((tcp_mask&0xFF000000)>>24);
EID003_CONFIG=0x10;
}

int Lit_tcp_adr()
{
int tcp_adr;
tcp_adr=EID003_adr.adr4;
tcp_adr|=(EID003_adr.adr3<<8)&0x0000ff00;
tcp_adr|=(EID003_adr.adr2<<16)&0x00ff0000;
tcp_adr|=(EID003_adr.adr1<<24)&0xff000000;
return tcp_adr;
}

int Lit_tcp_mask()
{
int tcp_mask;
tcp_mask=EID003_mask.adr4;
tcp_mask|=(EID003_mask.adr3<<8)&0x0000ff00;
tcp_mask|=(EID003_mask.adr2<<16)&0x00ff0000;
tcp_mask|=(EID003_mask.adr1<<24)&0xff000000;
return tcp_mask;
}


