/******************************************************************************/
/*	Cration d'un serveur HTLM								*/
/*	But du Programme:										*/
/*		Realisation d'un serveur HTTP1.1						*/
/*		Analyse des trames provenant d'Internet Explorer (IE)			*/
/*													*/
/******************************************************************************/

#include <string.h>
#include <stdio.h> 

#include "eid210.h"
#include "eid003.h"

#include "eid003_HTML.c"

/************************************/
/*	Programme principal		*/
/************************************/
main()
{
//int code_erreur;
clsscr();

//Initialisation des temps d'accs pour la carte EID210
Init_pc104_eid003();

//Configuration + ouverture du port TPC/IP Internet Explorer
SetPort(80);
EID003_CONFIG=0x01;

//Initialisation des varaibles
Init();

//principale
clsscr();
while(CRTL==1)
	{
	while(EID003_RX_COUNT==0);	//Si le buffer est vide, on attend
	clsscr(); 

	while(0==strstr(Buffer_reception.complet,standar[1])) //On receptionne tout le buffer 
	VideBufferRX();						//jusqu' \r\n\r\n

	code_erreur=0;
	//Verification des applications et de la langue supportes par le client 
	IndentifieLigneAccept();		//Formats supports
	IndentifieLigneLanguage();		//Quelle est la langue
	InRs232();					//Attente un appuie touche
	clsscr(); 	
	//On identifie tout les elements provenant de IE
	IndentifieLigneRequete();		//On identifie la ligne de requete Methode, URI_PAGE, VERSION_HTTP
	//On les affiche 
	AfficheBuffer(Buffer_reception.methode,2);
	AfficheBuffer(Buffer_reception.uri,4);
	AfficheBuffer(Buffer_reception.version,6);
	AfficheBuffer(Buffer_reception.complet,10);

	if(0!=strstr(Buffer_reception.version,version[0])) 	//Identifie la version HTTP1.1
		{
		code_erreur=code_erreur|0x0002; //code HTTP1.1
		printf("Version HTTP 1.1\n"); //HTTP1.1
		if(0!=strstr(Buffer_reception.methode,methode[0])) //Methode GET
			{
			code_erreur=code_erreur|0x0020; //code GET
			printf("Methode GET\n"); //code GET
			}
		if(0!=strstr(Buffer_reception.methode,methode[1])) //Methode POST
			{
			code_erreur=code_erreur|0x0040; //code POST
			printf("Methode POST\n"); 
			if(0!=strstr(Buffer_reception.complet,"Content-Length: "))//Si le Content-Length est present
				{
				while(EID003_RX_COUNT!=0) VideBufferRX();		//=> il faut recuperer le body venant de IE
				IndentifieLigneBody(Buffer_reception.body);	//Indentifier le body et le mettre dans son buffer 
				AfficheBuffer(Buffer_reception.body,8);
				}
			}	
		}
		else	//Ce n'est pas la version HTTP1.1 on en informe l'utilisateur 
		{	//et faire code_erreur=code_erreur|0x0004ou8.
			//Sinon on veut on peut traiter d'autres version ici
		printf("Il ne s'agit pas de la version HTTP1.1\n");
		}

	//Analyse_code_erreur(); //Analyse les erreurs 
	//Efface les variables de reception,d'identification et de reponses
	Init();
	}
}
