#include "eid003.h"

struct
{
char complet[1000];
char methode[10];
char uri[150];
char version[10];
	struct
	{
	char ToutType;
	char gif;
	char bitmap;
	char jpeg;
	char pjpeg;
	char word;
	char excel;
	}accept;
char body[150];
char tmp[100];
int cpt;
}Buffer_reception;

struct
{
char version[8];
char space;
char reason [50];
char crlf[2];
char doublecrlf[4];
char body[5000];
}Buffer_emission;

char Buff_tmp[15000];

char *methode[]={
"GET",
"POST",
"HEAD",
"DELAY"
};

char *version[]={
"HTTP/1.1",
"HTTP/1.0",
"HTTP/0.9"
};

char *standar[]={
"\r\n",
"\r\n\r\n",
"Content-Length: ",
};


int code_erreur;	//permet de connaitre d'ou vient une potentielle erreur
			//le  1er  octect :version HTTP: 	0=>non identifier
			//						2=>version 1.1
			//						4=>version 1.0
			//						8=>version 0.9
			//le 2eme octet : methode	:	0=>non trait
			//						2=>GET ou HEAD
			//						4=>POST
			//						8=>DELAY
			//le 3eme octet : page		:	0=>page non repertori
			//						2=>page repertori & identife
			//						4=>image repertori & identife

/************************************/
/*	Initialisation des variables	*/
/************************************/
void Init()
{
int i,j;

for(j=0;j<1000;j++) Buffer_reception.complet[j]='\0';
for(j=0;j<10;j++) Buffer_reception.methode[j]='\0';
for(j=0;j<150;j++) Buffer_reception.uri[j]='\0';
for(j=0;j<10;j++) Buffer_reception.version[j]='\0';
for(j=0;j<150;j++) Buffer_reception.body[j]='\0';
Buffer_reception.cpt=0;

for(j=0;j<8;j++) Buffer_emission.version[j]='\0';
Buffer_emission.space=' ';
for(j=0;j<50;j++) Buffer_emission.reason[j]='\0';
Buffer_emission.crlf[0]='\r';
Buffer_emission.crlf[1]='\n';
Buffer_emission.doublecrlf[0]='\r';
Buffer_emission.doublecrlf[1]='\n';
Buffer_emission.doublecrlf[2]='\r';
Buffer_emission.doublecrlf[3]='\n';
for(j=0;j<5000;j++) Buffer_emission.body[j]='\0';
}

/************************************/
/*	Gestion du buffer circulaire	*/
/************************************/
int VideBufferRX()
{

while(EID003_RX_COUNT>0)
	{
	Buffer_reception.complet[Buffer_reception.cpt]=EID003_BUFFER;
	Buffer_reception.cpt++;
	}
}

/******************************************************Identification de la requete provenant de IE*************************************/

/*************************************/
/*	Identification ligne de requete*/
/*************************************/
void IndentifieLigneRequete()
{
int retour;
int j,i;
	j=i=0;
	while(Buffer_reception.complet[j]!=' ')
	{
	Buffer_reception.methode[j]=Buffer_reception.complet[j]; 
	j++;
	}
Buffer_reception.methode[10]='\0';
	j++;
	i=j;
	while(Buffer_reception.complet[j]!=' ')
	{
	Buffer_reception.uri[j-i]=Buffer_reception.complet[j];
	j++;
	}
Buffer_reception.uri[150]='\0';

	j++;
	i=j;
	while(Buffer_reception.complet[j]!='\r')
	{
	Buffer_reception.version[j-i]=Buffer_reception.complet[j];
	j++;
	}
Buffer_reception.version[10]='\0';
}
/************************************************************************/
/*	Idenfification les types d'applications supportes par le client	*/
/************************************************************************/
void IndentifieLigneAccept()
{
unsigned int Search_accept,Search_accept_fin;
int i;

Search_accept=Search_String(Buffer_reception.complet,"Accept: ");

if(0!=strstr(Buffer_reception.complet,"*/*"))
	{
	Buffer_reception.accept.ToutType='Y';
	printf("Tout types d'applications supportes\n");
	}
	else
	{
	Buffer_reception.accept.ToutType='N';
	if(0!=strstr(Buffer_reception.complet,"gif"))
		Buffer_reception.accept.gif='Y';
			else Buffer_reception.accept.gif='N';
	if(0!=strstr(Buffer_reception.complet,"x-xbitmap"))
		Buffer_reception.accept.bitmap='Y';
			else Buffer_reception.accept.bitmap='N';
	if(0!=strstr(Buffer_reception.complet,"jpeg"))
		Buffer_reception.accept.jpeg='Y';
			else Buffer_reception.accept.jpeg='N';
	if(0!=strstr(Buffer_reception.complet,"pjpeg"))
		Buffer_reception.accept.pjpeg='Y';
			else Buffer_reception.accept.pjpeg='N';
	if(0!=strstr(Buffer_reception.complet,"ms-excel"))
		Buffer_reception.accept.excel='Y';
			else Buffer_reception.accept.excel='N';
	if(0!=strstr(Buffer_reception.complet,"msword"))
		Buffer_reception.accept.word='Y';
			else Buffer_reception.accept.word='N';
	printf("Applications supportes :\n gif=%c\n bitmap=%c\n jpeg=%c\n pjpeg=%c\n excel=%c\n word=%c\n ",Buffer_reception.accept.gif ,Buffer_reception.accept.bitmap ,Buffer_reception.accept.jpeg ,Buffer_reception.accept.pjpeg ,Buffer_reception.accept.excel ,Buffer_reception.accept.word);
	}
}

/************************************/
/*	Idenfification de le langue	*/
/************************************/
IndentifieLigneLanguage()
{
unsigned int Search_Langue;
char Language[2]; 
char *Langue[]={
"fr",
"en",
"de"
};

Search_Langue=Search_String(Buffer_reception.complet,"Accept-Language: ");

Language[0]=Buffer_reception.complet[Search_Langue];
Language[1]=Buffer_reception.complet[Search_Langue+1];
if(0!=strstr(Language,Langue[0])) printf("Version Francaise\n");
if(0!=strstr(Language,Langue[1])) printf("Version Anglaise\n");
if(0!=strstr(Language,Langue[2])) printf("Version Allemande\n");
}

/************************************/
/*	Recuperer le boby venet de IE	*/
/************************************/
void IndentifieLigneBody()
{
unsigned int nbsbody,place,i;

nbsbody=Search_String(Buffer_reception.complet,standar[2]);

if(!(isdigit(Buffer_reception.complet[nbsbody+1])))
	i=((Buffer_reception.complet[nbsbody])&0x0F); //si le body est <  10
	else
	if(!(isdigit(Buffer_reception.complet[nbsbody+2])))
		i=((Buffer_reception.complet[nbsbody])&0x0F)*10+((Buffer_reception.complet[nbsbody+1])&0x0F); //si le 9<body<100
		else
		if(!(isdigit(Buffer_reception.complet[nbsbody+3])))
		i=((Buffer_reception.complet[nbsbody])&0x0F)*100+((Buffer_reception.complet[nbsbody+1])&0x0F)*10+((Buffer_reception.complet[nbsbody+2])&0x0F); //si le body est >  99
				
nbsbody=i&0xFF;
place=Search_String(Buffer_reception.complet,"\r\n\r\n");

i=nbsbody+place;
nbsbody=0;
while(place!=(i))
	{
	Buffer_reception.body[nbsbody]=Buffer_reception.complet[place];
	place++;
	nbsbody++;
	}
}

/************************************/
/*	Affichage d'un buffer		*/
/************************************/
void AfficheBuffer(char *buff,int y)
{
gotoxy(1,y);
printf("%s\n",buff);
}

/******************************************************Repondre  une requete provenant de IE*************************************/

/************************************/
/*	Envoie d'un buffer		*/
/************************************/
/*
Fonctionnement:
EID003_BUFFER est un buffer circulaire:
chaque caractere ecrit dans ce buffer sera envoy dans le buffer de l'IP2222.
Lorsque le buffer de l'IP2222 est plein (soit tout les 128 caracteres), il est envoy automatiquement
Si le buffer de l'IP2222 n'est pas plein, et si il reste des caracteres a envoyer, il faudra forcer un envoie
*/
void EnvoiePageHTML(char HTML[])
{
	int j,i,tt;
	EID003_CONFIG = 0x01;			//Ouverture du Port
	Tempo(10000);				//tempo pour que le port s'ouvre

	j=0;
	i=(Search_String(HTML,"</html>"));	//tant que la fin du buffer(page) n'est pas identifi
	while(j!=i)				
	{
		EID003_BUFFER = HTML[j];	//Page dans le buffer 

		//Si on a plus de 30 caracteres dans le buffer de l'eid003,
		while(EID003_RX_COUNT>29);

		// on attend qu'ils soient transferer  automatiquement dans le buffer de l'IP2222
		//Tout les 128 caracteres l'envoie est automatiquement 
		//fait, mais il faut attendre avant de mettre les caracteres suivants
		while((EID003_STATUS&0x04)==0x04);

		//Nanmoins en fonction des versions de l'IP2022, l'envoie doit etre fait manuellement
		if((j%1200)==0) EID003_CONFIG=0x03;	

		if(j==(i-1))			//Envoie le reste du buffer 
		{
			while(EID003_TX_COUNT!=0);
			EID003_CONFIG = 0x03;	//Envoie buffer
			while((EID003_STATUS&0x04)==0x04);//Attendre fin de l'envoie
		}
		j++;
	for(tt=0;tt<100;tt++); //necessaire sur les anciennes cartes rseau
	}
//Fini le buffer par un doublecrlf (il est place ici (et non dans reponse_requete) pour permettre de ce servir 
//de cette sous fonction dans le cas d'une version HTPP0.9)
	Tempo(50);	//tempo imperative avant d'envoyer le doublecrlf marquant la fin de reponse
	EID003_BUFFER='\r';
	EID003_BUFFER='\n';
	EID003_BUFFER='\r';
	EID003_BUFFER='\n';
	EID003_CONFIG = 0x03;	//Envoie buffer
	while((EID003_STATUS&0x04)==0x04);//Attendre fin de l'envoie

	EID003_CONFIG = 0x02;	//Fermeture du Port
	Tempo(10000); 
}

/************************************************************/
/*	Constituer un buffer respentant la norme HTTP1.1	*/
/************************************************************/
// Gerer la page  envoyer pour la rendre compatible avec la vesion HTTP/1.1 et HTTP/1.0
void 	Reponse_Requete(char Page_HTML[],char Reason[]) //Page  envoyer,Body
{
int i,j;

code_erreur=code_erreur|0x0200; //code page
i=strlen(Buff_tmp);
for(j=0;j<i;j++) Buff_tmp[j]='\0';

//Reponse standar de HTTP1.1 : HTTP/1.1 Status-Code Reason-Phrase Reour-a-la-lingeRetour-a-la-Ligne Body
for(j=0;j<8;j++) Buffer_emission.version[j]=Buffer_reception.version[j]; //Version de HTTP
strcat(Buff_tmp,Buffer_emission.version);

Buffer_emission.space=' ';
strcat(Buff_tmp," "); //Buffer_emission.space);

i=strlen(Reason);
for(j=0;j<i;j++) Buffer_emission.reason[j]=Reason[j]; //Mise en place du Status-Code,espace,Reason-Phrase 
strcat(Buff_tmp,Buffer_emission.reason);

Buffer_emission.doublecrlf[0]='\r';
Buffer_emission.doublecrlf[1]='\n';
Buffer_emission.doublecrlf[2]='\r';
Buffer_emission.doublecrlf[3]='\n';
strcat(Buff_tmp,Buffer_emission.doublecrlf);

i=strlen(Page_HTML);
for(j=0;j<i;j++) Buffer_emission.body[j]=Page_HTML[j]; //Mise en place du \r\n\r\n

strcat(Buff_tmp,Buffer_emission.body);

EnvoiePageHTML(Buff_tmp); 		// On envoie tout le buffer

//Efface
i=strlen(Buff_tmp);
for(j=0;j<i;j++) Buff_tmp[j]='\0';
}

/******************************/
/*	Envoie d'une image	*/
/******************************/
void EnvoieImage(char Img[],int Taille)
{
int j,i,tt;

EID003_CONFIG = 0x01;		//Ouverture du Port
Tempo(10000); 
code_erreur=code_erreur|0x0400; //code image

	j=0;
	while(j!=Taille)
	{
		EID003_BUFFER =Img[j];	//Page dans le buffer 

		//Si on a plus de 30 caracteres dans le buffer de l'eid003,
		// on attend qu'ils soient transferer  automatiquement dans le buffer de l'IP2222
		while(EID003_RX_COUNT>29);	

		//Tout les 128 caracteres l'envoie est automatiquement 
		//fait, mais il faut attendre avant de mettre les caracteres suivants
		while((EID003_STATUS&0x04)==0x04);

		//Nanmoins en fonction des versions de l'IP2022, l'envoie doit etre fait manuellement
		if((j%1200)==0) EID003_CONFIG=0x03;	
						
		if(j==(Taille-1))			
		{
			while(EID003_TX_COUNT!=0);
			EID003_CONFIG = 0x03;	//Envoie buffer
			while((EID003_STATUS&0x04)==0x04);//Attendre fin de l'envoie
		}
		j++;
	for(tt=0;tt<100;tt++); //necessaire sur les anciennes cartes rseau
	}
Tempo(50);	//tempo imperative avant d'envoyer le doublecrlf marquant la fin de reponse
EID003_BUFFER='\r';
EID003_BUFFER='\n';
EID003_BUFFER='\r';
EID003_BUFFER='\n';
EID003_CONFIG = 0x08;	//Envoie buffer
while((EID003_STATUS&0x04)==0x04);//Attendre fin de l'envoie

EID003_CONFIG = 0x02;	//Fermeture du Port
Tempo(10000); 
}

/************************************************************************/
/*	Constituer un buffer respentant la norme HTTP1.1 pour une image	*/
/************************************************************************/
void Reponse_Image(char Image[],char Reason[],int Taille)
{
int j,i;

i=strlen(Buff_tmp);
for(j=0;j<i;j++) Buff_tmp[j]='\0';
//Reponse standard
//Version HTTP
i=strlen(Buffer_reception.version);
for(j=0;j<i;j++) Buffer_emission.version[j]=Buffer_reception.version[j]; 
strcat(Buff_tmp,Buffer_emission.version);
//space
Buffer_emission.space=' ';
strcat(Buff_tmp," ");
//Reason
i=strlen(Reason);
for(j=0;j<i;j++) Buffer_emission.reason[j]=Reason[j];  
strcat(Buff_tmp,Buffer_emission.reason);
//le double crfl
Buffer_emission.doublecrlf[0]='\r';
Buffer_emission.doublecrlf[1]='\n';
Buffer_emission.doublecrlf[2]='\r';
Buffer_emission.doublecrlf[3]='\n';
strcat(Buff_tmp,Buffer_emission.doublecrlf);
//Le body
j=strlen(Buff_tmp);
for(i=j;i<(Taille+j);i++) Buff_tmp[i]=Image[i-j]; 

//Envoie
EnvoieImage(Buff_tmp,j+Taille);	//Envoie code

//Efface
i=strlen(Buff_tmp);
for(j=0;j<i;j++) Buff_tmp[j]='\0';
}

/************************************/
/*	Gestion des Erreurs		*/
/************************************/
void Analyse_code_erreur()
{
int cde_err;

}

/************************************/
/*	Fonction de recherche		*/
/************************************/
int Search_String(char *ptr1,char *ptr2)
{
char *ptr;
int ret=0;
	(int) ptr=strstr(ptr1,ptr2);	//Fonction permetant de retrouver une chaine dans une autre et retourne un pointeur sur le debut de chaine (ex ptr2=AZERTY, prt1=ER, => ptr pointe sur E
		ret =(ptr-ptr1)+strlen(ptr2);
		if(ret<0) ret=0; 
	return ret;
}

/************************************/
/*	Fonction de temporisation	*/
/************************************/
int Tempo(int time)
{
int aaa;
for(aaa=0;aaa<time;aaa++); 
}