/* startup pour EID210000

*/
	.title "CRT pour EID210"

/* These are predefined by new versions of GNU cpp.  */

.global	start
.global	exit

.global getch
.global clsscr
.global gotoxy

.set SCSR,0xFFFC0C
.set SCDR,0xFFFC0E



start:

	clr.l	%d0
	clr.l	%d1
	clr.l	%d2
	clr.l	%d3
	clr.l	%d4
	clr.l	%d5
	clr.l	%d6
	clr.l	%d7
	move.l	#__stack , %sp

	jsr	main

exit:

	jmp 0x400	/* retour au moniteur */

out_rs:		move.w	SCSR,%d0
		and.w		#0x0100,%d0
		beq.s		out_rs
		move.w	%d3,SCDR	
		rts
getch:
in_rs:		move.w	SCSR,%d0
		and.w		#0x0040,%d0
		beq.s		in_rs
		move.w	SCDR,%d0
		rts

clsscr:		movem.l	%d3,-(%sp)
		move.b	#27,%d3
		jsr		out_rs
		move.b	#'H',%d3
		jsr		out_rs
		movem.l	(%sp)+,%d3
		rts

gotoxy:	movem.l	%d1-%d3,-(%sp)
		move.l		16(%sp),%d1
		move.l		20(%sp),%d2
		add.b		#31,%d1
		add.b		#31,%d2
		move.b	#27,%d3
		jsr		out_rs
		move.b	#'Y',%d3
		jsr		out_rs
		move.b	%d2,%d3	/* d2=Y */
		jsr		out_rs
		move.b	%d1,%d3	/* d1=X */
		jsr		out_rs
		movem.l	(%sp)+,%d1-%d3
		rts
