/******************************************************
*	TP SUR LA CARTE EID005					*
*******************************************************
*	Ecrire un programme en C				*
*	qui ralise la lecture d'un touche			*
*	sur un clavier matric 4 x 4, en mode pooling	*
*	La touche appuy sera affiche sur le moniteur	*
*	et sur l'afficheur lcd					*
*	On quittera le programme lorsque toutes les 	*
*	touches auront toutes t test			*
*******************************************************
*	Nom du FICHIER : TP4.c					*
*	**************						*	
******************************************************/

//	Inclusion des fichiers de dfinition

#include "eid005.h"

//============================
//   	FONCTION PRINCIPALE 
//============================


main ()
{ 
int tch_app=0x0000;	//savoir quelles touches ont t appuyes? msb=>F lsb=>0

short    Touche[4][4] = { 0x0A, 0x00, 0x0B, 0x0F,
				  0x07, 0x08, 0x09, 0x0E,
				  0x04, 0x05, 0x06, 0x0D,
				  0x01, 0x02, 0x03, 0x0C } ;
short V, ValeurTouche; 
int tmp ;
int i, j, k ;

// Prparation pour affichage sur LCD
init_aff();			// Initialisation de l'afficheur
lcd_cls();			// Effacement de l'afficheur
lcd_gotoxy(0x30,00);	// Dfinition de la position de dpart 
				// de la chane de caractres


// Balyage des lignes du clavier en donnant successivement  la variable
// clavier.matrice.ligne, les quartets  : 1110, 1101, 1011, 0111 .  

printf ("\n-------------------------\n");
printf ("TESTER TOUTES LES TOUCHES \n");
printf ("------------------------- \n\n");

j=0;
do
{j++;
printf ("Appuyer sur une touche \n"); 

//	Touche appuye ?
//	Balayage ligne

while ((clavier.matrice.colonne & 0x0F) == 0x0F)	// Attente appui touche
{
	for (i = 0; i<4; i++ )
	{	
		clavier.matrice.ligne = ~(1 << i); 	// Toutes les colonnes 
								//  1 sauf la n i	
		tmp = i;
		if (touche == 1) break;			// touche = 1 ==> au moins 
								// une touche appuye		
		for (k = 0 ; k<10000 ; k++);		// temporisation
 	}
}

switch((~(clavier.matrice.colonne)) & 0x0F )
{
	case 1 : ValeurTouche= Touche [tmp][3]; break; 		//Colonne pods 1
	case 2 : ValeurTouche= Touche [tmp][2]; break; 		//Colonne pods 2 
	case 4 : ValeurTouche= Touche [tmp][1]; break;		//Colonne pods 4
	case 8 : ValeurTouche= Touche [tmp][0]; break;		//Colonne pods 8 	
}	

//reperer les touches appuy, pour savoir si on quitte
switch(ValeurTouche)
{
	case 0x00 : tch_app|=0x0001;break; //la touche 0 a t appui
	case 0x01 : tch_app|=0x0002;break; //la touche 1 a t appui
	case 0x02 : tch_app|=0x0004;break;
	case 0x03 : tch_app|=0x0008;break;
	case 0x04 : tch_app|=0x0010;break;
	case 0x05 : tch_app|=0x0020;break;
	case 0x06 : tch_app|=0x0040;break;
	case 0x07 : tch_app|=0x0080;break;
	case 0x08 : tch_app|=0x0100;break;
	case 0x09 : tch_app|=0x0200;break;
	case 0x0A : tch_app|=0x0400;break;
	case 0x0B : tch_app|=0x0800;break;
	case 0x0C : tch_app|=0x1000;break;
	case 0x0D : tch_app|=0x2000;break;
	case 0x0E : tch_app|=0x4000;break;
	case 0x0F : tch_app|=0x8000;break;
}	



// Afficher la valeur de la touche  l'cran du PC

printf ("La touche appuyee est : %x\n\n", ValeurTouche );

// Afficher la valeur de la touche sur l'cran LCD

if(ValeurTouche < 0x0A)		// Conversion hexa --> ASCII : chiffres
V = ValeurTouche+0x10;
else
V = ValeurTouche+0x17;		// Conversion hexa --> ASCII : lettres
lcd_write_data(V);		// Envoi du cartre au LCD
lcd_write_command(0xC0);	// Incrmentation pour la position 
					// du caractre suivant


while (touche)			// Attente relche touche
for (k = 0 ; k<10000 ; k++);	// Temporisation 
	
}
//	Toutes les touches sont testes ?
while (tch_app!=0xFFFF);
}



