#include "mtr86.h"

#define P(s)  s_wait(s, 0)
#define V(s)  s_signal(s)
SEMAPHORE SemN, SemS;
SEMAPHORE mutexN, mutexS;  

int bN, bS;      // compteurs de baboins actifs

void entrer_S(void)
{
  P(SemS);
  P(mutexS);    // exclusion section critique
  if (bS==0)    // dbut de section critique 
    P(SemN);    // bloquer les babouins cot nord 
  bS++;         // un babouin de plus
  V(SemS);      // Relancer vntuellement un babouin 
  printf("->ES\n"); 
  V(mutexS);
}

void entrer_N(void)
{
  P(SemN);
  P(mutexN);    // exclusion section critique
  if (bN==0)    // dbut de section critique
    P(SemS);    // bloquer les babouins cot nord
  bN++;         // un babouin de plus
  V(SemN);      // Relancer vntuellement un babouin 
  printf("->EN\n"); 
  V(mutexN);
}          

void sortir_N(void)
{
 P(mutexS);  
 bS--;
 if (bS==0)
   V(SemN);
 V(mutexS);
 printf("SN->\n"); 
}

void sortir_S(void)
{
 P(mutexN);  
 bN--;
 if (bN==0)
   V(SemS);
 V(mutexN);
 printf("SS->\n"); 
}

TACHE babouinN(void)
{
  entrer_N();
  dort(100);
  sortir_S();
}

TACHE babouinS(void)
{
  entrer_S();
  dort(100);
  sortir_N();
}

 

TACHE init(void)
{
  int i;
  SemN = s_cree(1);
  SemS = s_cree(1);
  mutexN = s_cree(1);
  mutexS = s_cree(1);
  bS=0; bN=0;
  for (i=0; i< 4; i++)
  {
    active(cree(babouinN, 2, 1024));
    active(cree(babouinS, 2, 1024));
  }
}

main()
{
  cputs("Resolution du probleme des baboins\n");
  InitSimulateur();
  start_mtr(init,512);
}
