
/* gestion du simulateur d'e/s avec mtr86 */

#include "mtr86.h"
#include "eid210.h"

SEMAPHORE sem1;
char flag_arb;

void Irq_Sim()
{
VAL_IRQ_PORT=1;
if (flag_arb==0)
	{
	flag_arb=1;
	s_signal(sem1);
	}
VAL_IRQ_PORT=0;
}

TACHE Aff_7seg()
{
char compteur;
compteur=0;
InitAff();
while(1)
	{
	EcritAff(compteur);
	if (compteur==10)
		compteur=0;
		else
		compteur++;
	MONITOR
	gotoxy(5,5);
	printf("compteur=%d \n",compteur);
	ENDM
	dort(100);
	}
}

TACHE Can()
{
short v_ana;
while(1)
	{
	CAN=0x50;
	while(IRQ_CAN)
		dort(1);
	v_ana=CAN&0xFFF;
	MONITOR
	gotoxy(5,6);
	printf("E_ANA(0)=%3X  \n",v_ana);
	ENDM
	dort(10);
	}
}

void t_irq()
{
int compteur1;
compteur1=0;
flag_arb=0;
SetVect(30,&Irq_Sim);
Irq4=1;
while(1)
	{
	s_wait(sem1,0);
	flag_arb=0;
	MONITOR
	gotoxy(5,7);
	printf("IRQ=%d  \n",compteur1);
	ENDM
	compteur1++;
	}
}


TACHE InitSimulateur()
{
sem1=s_cree(0);
active(cree(Aff_7seg,2,1024));
active(cree(Can,2,1024));
active(cree(t_irq,2,1024));
}

main()
{
clsscr();
gotoxy(5,2);
printf("Simulateur d'entree et de sortie\n");
start_mtr(InitSimulateur,512);
}