	/*************************************************************************
	* 		TP SUR EID210 seul					*
	*************************************************************************
	*  Faire un chenillard avec les 3 leds sur le port QS                   	* 			
	*								      	*	
	*  Cahier des charges						      	*
	* **********************						      	*	
	*  Les leds s'allument suivant le cycle 			      	*
	*              D10 -> D11 -> D12 -> D10 ... etc                                    	*
	*  Le temps pendant lequel une led s'allume est d'environ 1S   	*
	*  Ce temps sera gnr par une boucle "logiciel"		      	*		
	*  NOM du FICHIER:  CHENI_1.C				       	*
	* ********************							*
	*************************************************************************/

/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "structures_donnees.h"
#include <stdio.h>

/* Dclaration des variables*/
 

/*=====================*/
/*      Fonction principale     */
/*=====================*/
main()
{
/* Dclarations *
*****************/
BYTE e_portqs;		/* Variable sur 8 bits donnant l'tat du port QS donc des LEDs */
unsigned int i;			/* Pour temporisation logiciel  */

/*   Initialisations *
*********************/
e_portqs=0x10;
PQSCTR=0x0070;		/* Les 3 sorties sur lesquelles sont connectes les leds*/ 
				/* seront des sorties PQS(6..3) */

/* On crit un message sur le moniteur */
printf("Permutation des LEDs  D12 D11 D10  chaque seconde\n");
printf("       La temporisation est de type logiciel\n");
/* Boucle principale *
**********************/    
	do
	{  	// ecriture Valeur sur le port QS 
	   PORTQS=e_portqs;  
		//  Attendre environ 1S  (Tempo logiciel)
	   for(i=0;i<=300000;i++);
		//  Prparation aux tats futurs				
	  e_portqs<<=1;		    	  
	  if (e_portqs==0x80)	e_portqs=0x10;
    	}while(1);  				/*  Fin de la boucle principale */

} /* Fin de la fonction principale */

 
