


#include "eid210.h"

#include "feux.h"

void InitMeteo()
{

CFSR0=(short)0x8888;
CFSR1=(short)0x8888;
CFSR2=(short)0x8888;
CFSR3=(short)0x8888;

HSQR0=(short)0;
HSQR1=(short)0;
CPR0=(short)0xFFFF;
CPR1=(short)0xFFFF;
CTRL_TPU0=(short)0x0003;
CTRL_TPU1=(short)0x0003;
CTRL_TPU2=(short)0x0003;
CTRL_TPU3=(short)0x0003;
CTRL_TPU4=(short)0x0003;
CTRL_TPU5=(short)0x0003;
CTRL_TPU6=(short)0x0003;
CTRL_TPU7=(short)0x0003;

CTRL_TPU8=(short)0x0003;
CTRL_TPU9=(short)0x0003;
CTRL_TPU10=(short)0x0003;
CTRL_TPU11=(short)0x0003;
CTRL_TPU12=(short)0x0003;
CTRL_TPU13=(short)0x0003;
CTRL_TPU14=(short)0x0003;
CTRL_TPU15=(short)0x0003;

HSRR0=0xFfFF;
HSRR1=0xFFFF;

HSRR0=0xAaAA;
HSRR1=0x5555;

/* initialisation du port C*/

PortCDir=0xFF;
PortCPort=0x00;

/*Retour capture du portB*/
#define ValPB4 *(short*)(0xFFFFC2)	//C correspond a PB3 => erreur de cablage??
#define ValPB5 *(short*)(0xFFFFD2)	//D correspond a PB2 => erreur de cablage??
}


short vit_vent()
{
short v_vent;
int time;
v_vent=time=0;
for(time=0;time<1000000;)	//boucle de 5s exacte
	{
	HSRR0=0x0F00;	//Capture PB
	time=time+2;
	while(!(ValPB5&0x8000) && time<1000000) //attent front montant	
		{
		HSRR0=0x0F00;
		time=time+5;
		}
	v_vent++;
	time=time+5;
	while((ValPB5&0x8000) && time<1000000) //attent front descendant
		{
		HSRR0=0x0F00;
		time=time+5;
		}
	time=time+4;
	}
return v_vent;
}

short vit_vent_sim()
{
short v_vent_sim;
int time;
v_vent_sim=time=0;
for(time=0;time<1000000;)
	{
	HSRR0=0x0F00;	//Capture PB
	time=time+2;
	while(!(ValPB4&0x8000)) //attent front montant	
		{
		HSRR0=0x0F00;
		time=time+5;
		}
	v_vent_sim++;
	time=time+5;
	while((ValPB4&0x8000)) //attent front descendant
		{
		HSRR0=0x0F00;
		time=time+5;
		}
	time=time+4;
	}
return v_vent_sim;
}

main()
{
short vitesse_vent,vitesse_vent_sim;
clsscr();
InitMeteo();

	for(;;)
	{
	vitesse_vent=(vit_vent())*1.359;	//0.3883recuperation de la valeur+conversion
	vitesse_vent=vitesse_vent&0x1ff; //masque pour affichage en decimal
	gotoxy(1,10);
	printf("\n vitesse du vent: %d Km/h \n",vitesse_vent); 

//Vitesse du vent simul
	vitesse_vent_sim=(vit_vent_sim())*1.359;	//recuperation de la valeur+conversion
	vitesse_vent_sim=vitesse_vent_sim&0x1ff; //masque pour affichage en decimal
	gotoxy(1,14);
	printf("\n vitesse du vent simul : %d Km/h \n",vitesse_vent_sim); 

	}
}