/***********************************************************************
 * Module:  CCommodo.h
 * Author:  clems
 * Modified: lundi 24 janvier 2005 14:59:14
 * Purpose: Declaration of the class CCommodo
 ***********************************************************************/

#if !defined(__Globale_CCommodo_h)
#define __Globale_CCommodo_h

#include "PeripheriquesCAN_Entree.h"
#include "CControleurCan.h"

class CCommodo : public PeripheriquesCAN_Entree
{
public:
   int DecoderTrame(void);
   int ConstruireTrame(void);
   unsigned char RecevoirEtat(void);
   CCommodo(int , CControleurCan* );
   bool EstVeilleuse();
   bool EstCode();
   bool EstPhare();
   bool EstClignotantGauche();
   bool EstClignotantDroit();
   bool EstKlaxon();

protected:
private:



};

#endif