/***********************************************************************
 * Module:  PeripheriqueCAN_Sortie.cpp
 * Author:  clems
 * Modified: vendredi 21 janvier 2005 13:55:41
 * Purpose: Implementation of the class PeripheriqueCAN_Sortie
 ***********************************************************************/


#include "Structures_Donnees.h"
#include "cpu_reg.h"
#include "eid210_reg.h"
#include "Can_vmd.h"
#include "PeripheriqueCAN_Sortie.h"


#include "CControleurCan.h"

////////////////////////////////////////////////////////////////////////
// Name:       PeripheriqueCAN_Sortie::PeripheriqueCAN_Sortie()
// Purpose:    Implementation of PeripheriqueCAN_Sortie::PeripheriqueCAN_Sortie()
// Constructeur
////////////////////////////////////////////////////////////////////////

PeripheriqueCAN_Sortie::PeripheriqueCAN_Sortie(int Addr ,CControleurCan* ctrlcan): PeripheriquesCAN(Addr,ctrlcan)
{


 
}


////////////////////////////////////////////////////////////////////////
// Name:       PeripheriqueCAN_Sortie::EnvoyerEtat()
// Purpose:    Implementation of PeripheriqueCAN_Sortie::EnvoyerEtat()
// Return:     int
////////////////////////////////////////////////////////////////////////

int PeripheriqueCAN_Sortie::EnvoyerEtat(void)
{

PeripheriquesCAN::EnvoyerEtat();


}

////////////////////////////////////////////////////////////////////////
// Name:       PeripheriqueCAN_Sortie::FaireChenillard()
// Purpose:    Implementation of PeripheriqueCAN_Sortie::FaireChenillard()
// Return:     void
////////////////////////////////////////////////////////////////////////

void PeripheriqueCAN_Sortie::FaireChenillard(void)
{
   // TODO : implement
int tmp,cpt;
Data[0]=0x1E;
Data[1]=0x0F;
Data[2]=0;
tr_IM.SetAdresse(Adresse);
tr_IM.SetDonnee(Data,3);
//ctrl_can->EcrireTrame(tr_IM);//envoie la trame sur le controleur CAN
PeripheriquesCAN::EnvoyerEtat();


for(cpt=0;cpt<=4;cpt++)
{
Data[2]=0x01<<cpt;//chenillard
tr_IM.SetDonnee(Data,3);
PeripheriquesCAN::EnvoyerEtat();
//ctrl_can->EcrireTrame(tr_IM);//envoie la trame sur le controleur CAN
for(tmp=0;tmp<500000;tmp++);//attendre
}

}