/***********************************************************************
 * Module:  PeripheriquesCAN.h
 * Author:  clems
 * Modified: lundi 24 janvier 2005 15:02:56
 * Purpose: Declaration of the class PeripheriquesCAN
 ***********************************************************************/

#if !defined(__Globale_PeripheriquesCAN_h)
#define __Globale_PeripheriquesCAN_h

class CTrame;

#include "Peripheriques.h"
#include "CControleurCan.h"

class PeripheriquesCAN : public Peripheriques
{
public:
   int DecoderTrame(void);
   int ConstruireTrame(void);
   int EnvoyerEtat(void);
   unsigned char RecevoirEtat(void);
   PeripheriquesCAN(int Addr, CControleurCan* ctrlcan);

  
   
  

protected:
   CControleurCan * ctrl_can;
   int Adresse;//adresse de la carte peripherique
   char etat;//etat des entres /sorties
   unsigned char Data[20];
   CTrame tr_IM;

private:

};

#endif