//Fichier  inclure 


#include "Peripheriques.h"
#include "CControleurCan.h"
#include "CBlocOptique.h"
#include "CBlocOptiqueArriere.h"
#include "CBlocOptiqueAvant.h"
#include "CTrame.h"
#include "CAnalyseurCan.h"
#include "CCommodo.h"
#include "CCommodoLumiere.h"
#include <stdio.h>




main()
{
int tmp,cpt,clt;
unsigned char entree;
CAnalyseurCan analiseur;
CControleurCan ctrl_can(&analiseur);//creation d'un objet controleur can
ctrl_can.ActiveAnalyse(false);
CCommodoLumiere com_feu(0x05041E07,&ctrl_can);
CBlocOptiqueAvant bloc_feu_Avdroit(0xE880000,&ctrl_can);
CBlocOptiqueAvant bloc_feu_Avgauche(0xE080000,&ctrl_can);
CBlocOptiqueArriere bloc_feu_Ardroit(0xF880000,&ctrl_can);
CBlocOptiqueArriere bloc_feu_Argauche(0xF080000,&ctrl_can);



while(1)
{
com_feu.RecevoirEtat();
if(com_feu.EstVeilleuse()==true)
{
	//printf("   Veilleuse\n");
	bloc_feu_Avdroit.AllumerVeilleuse();
	bloc_feu_Argauche.AllumerVeilleuse();
	bloc_feu_Ardroit.AllumerVeilleuse();
	bloc_feu_Avgauche.AllumerVeilleuse();
}
else
{
	//printf("pas Veilleuse\n");
	bloc_feu_Avdroit.EteindreVeilleuse();
	bloc_feu_Argauche.EteindreVeilleuse();
	bloc_feu_Ardroit.EteindreVeilleuse();
	bloc_feu_Avgauche.EteindreVeilleuse();
}
if(com_feu.EstCode()==true)
{
	//printf("   Code\n");
	bloc_feu_Avdroit.AllumerCode();
	bloc_feu_Avgauche.AllumerCode();
}
else
{
	//printf("pas Code\n");
	bloc_feu_Avdroit.EteindreCode();
	bloc_feu_Avgauche.EteindreCode();
}
if(com_feu.EstPhare()==true)
{
	//printf("  Phare\n");
	bloc_feu_Avdroit.AllumerPhare();
	bloc_feu_Avgauche.AllumerPhare();
}
else
{
	//printf("pas Phare\n");
	bloc_feu_Avdroit.EteindrePhare();
	bloc_feu_Avgauche.EteindrePhare();
}
if(com_feu.EstClignotantDroit()==true)
{
bloc_feu_Avgauche.EteindreClignotant();
bloc_feu_Argauche.EteindreClignotant();

	if(clt<5)
	{
		bloc_feu_Ardroit.AllumerClignotant();
		bloc_feu_Avdroit.AllumerClignotant();
		

	}
	else
	{
	bloc_feu_Ardroit.EteindreClignotant();
	bloc_feu_Avdroit.EteindreClignotant();
	if(clt>10)
		clt=0;
	}
clt++;

}
else if (com_feu.EstClignotantGauche()==true)
{
printf("clignotant gauche\n");
bloc_feu_Avdroit.EteindreClignotant();
bloc_feu_Ardroit.EteindreClignotant();

	if(clt<5)
	{
		bloc_feu_Argauche.AllumerClignotant();
		bloc_feu_Avgauche.AllumerClignotant();
		
	}
	else
	{
	bloc_feu_Argauche.EteindreClignotant();
	bloc_feu_Avgauche.EteindreClignotant();
	if(clt>10)
		clt=0;
	}
clt++;

}
else 
{
printf("pas clignotant gauche\n");
bloc_feu_Avgauche.EteindreClignotant();
bloc_feu_Avdroit.EteindreClignotant();
bloc_feu_Argauche.EteindreClignotant();
bloc_feu_Ardroit.EteindreClignotant();
cpt=0;

}

if(com_feu.LireEtatEntree2()==true)
{
bloc_feu_Argauche.AllumerStop();
bloc_feu_Ardroit.AllumerStop();
}
else
{
bloc_feu_Argauche.EteindreStop();
bloc_feu_Ardroit.EteindreStop();
}


if(com_feu.EstKlaxon()==true)
{
bloc_feu_Argauche.AllumerKlaxon();

}
else
bloc_feu_Argauche.EteindreKlaxon();



bloc_feu_Avgauche.EnvoyerEtat();
bloc_feu_Avdroit.EnvoyerEtat();
bloc_feu_Argauche.EnvoyerEtat();
bloc_feu_Ardroit.EnvoyerEtat();

//test Feux Arriere
if(bloc_feu_Ardroit.TestClignotant()==false)
printf("clignotantArD HS\n");
if(bloc_feu_Ardroit.TestVeilleuse()==false)
printf("VeilleuseArD HS\n");
if(bloc_feu_Ardroit.TestStop()==false)
printf("StopArD HS\n");
if(bloc_feu_Argauche.TestClignotant()==false)
printf("clignotantArG HS\n");
if(bloc_feu_Argauche.TestVeilleuse()==false)
printf("VeilleuseArG HS\n");
if(bloc_feu_Argauche.TestStop()==false)
printf("StopArG HS\n");
if(bloc_feu_Argauche.TestKlaxon()==false)
printf("SKlaxonArG HS\n");

//test Feux Avant
if(bloc_feu_Avdroit.TestClignotant()==false)
printf("clignotantAvD HS\n");
if(bloc_feu_Avdroit.TestVeilleuse()==false)
printf("VeilleuseAvD HS\n");
if(bloc_feu_Avdroit.TestCode()==false)
printf("CodeAvD HS\n");
if(bloc_feu_Avdroit.TestPhare()==false)
printf("PhareAvD HS\n");
if(bloc_feu_Avgauche.TestClignotant()==false)
printf("clignotantAvD HS\n");
if(bloc_feu_Avgauche.TestVeilleuse()==false)
printf("VeilleuseAvD HS\n");
if(bloc_feu_Avgauche.TestCode()==false)
printf("CodeAvD HS\n");
if(bloc_feu_Avgauche.TestPhare()==false)
printf("PhareAvD HS\n");


for(tmp=0;tmp<10000;tmp++);
}

}
