/***********************************************************************
 * Module:  CAnalyseurCan.cpp
 * Author:  clems
 * Modified: jeudi 20 janvier 2005 08:53:28
 * Purpose: Implementation of the class CAnalyseurCan
 ***********************************************************************/
#include "Structures_Donnees.h"
#include "cpu_reg.h"
#include "eid210_reg.h"
#include "CAnalyseurCan.h"
#include "CTrame.h"


////////////////////////////////////////////////////////////////////////
// Name:       CAnalyseurCan::AfficherTrameRecue()
// Purpose:    Implementation of CAnalyseurCan::AfficherTrameRecue()
// Return:     int
////////////////////////////////////////////////////////////////////////

int CAnalyseurCan::AfficherTrameRecue(CTrame tr )
{
	Trame trame=tr.LitTrame();
printf("Trame Recue\n");
unsigned char i;
printf("Ext=%d, RTR=%d, dlc=%d, ",trame.trame_info.champ.extend,
					trame.trame_info.champ.rtr,
					trame.trame_info.champ.dlc);
if (trame.trame_info.champ.extend)
	printf("IDENTIFICATEUR=%8.8x, ",trame.ident.extend.identificateur.ident);
	else
	printf("IDENTIFICATEUR=%4.4x, ",trame.ident.standard.identificateur.ident);
if (trame.trame_info.champ.rtr==0)
	{
	printf("DATA= ");
	for(i=0;i<trame.trame_info.champ.dlc;i++)
		printf("%2.2x, ",trame.data[i]);
	}
	else
	printf("                                                      ");
printf("\n"); 
 	
}

////////////////////////////////////////////////////////////////////////
// Name:       CAnalyseurCan::AfficherTrameEnvoyee()
// Purpose:    Implementation of CAnalyseurCan::AfficherTrameEnvoyee()
// Return:     int
////////////////////////////////////////////////////////////////////////

int CAnalyseurCan::AfficherTrameEnvoyee(CTrame tr)
{
		Trame trame=tr.LitTrame();
printf("Trame envoye\n");
unsigned char i;
printf("Ext=%d, RTR=%d, dlc=%d, ",trame.trame_info.champ.extend,
					trame.trame_info.champ.rtr,
					trame.trame_info.champ.dlc);
if (trame.trame_info.champ.extend)
	printf("IDENTIFICATEUR=%8.8x, ",trame.ident.extend.identificateur.ident);
	else
	printf("IDENTIFICATEUR=%4.4x, ",trame.ident.standard.identificateur.ident);
if (trame.trame_info.champ.rtr==0)
	{
	printf("DATA= ");
	for(i=0;i<trame.trame_info.champ.dlc;i++)
		printf("%2.2x, ",trame.data[i]);
	}
	else
	printf("                                                      ");
printf("\n"); 
}