
	/*************************************************************************
	*     TP sur  EID210 avec SIMULATEUR D'ENTREES SORTIES	*
	*************************************************************************
	*	 Affichage sur 7 segments de l'entre analogique		*
	*  	 n 0 (celle du potentiomtre)					*
	*								      	*	
	*  Cahier des charges:					      	*
	*   **********************					      	*	
	*  On affiche un nombre hexadcimal (entre 0 et 15)			*
	*  qui correspond aux poids forts du rsultat de conversion		*
	*  de l'entre analogique E0  						*
	*  (impose par la position du potentiomtre)			*
	* ---------------------------------------------------------------------------------------------------
	*  NOM du FICHIER:  CAN_Port_C.C			       		*
	* ********************							*
	*************************************************************************/
/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Simulateur_ES.h"
#include "Structures_donnees.h"

//************************
//    DECLARATIONS     *
//************************

/* Declaration des prototypes des fonctions */
void AFFICHER(unsigned char);

//****************************************
//	FONCTION PRINCIPALE 	
//****************************************

main()
{
/*Variable locale*/
unsigned short resultat_conv;
unsigned char val_aff;

//  Initialisations
//*****************

/*Initialisation de l'afficheur*/
DirPortC=0xFF;

//Dbut de la boucle principale
//********************************
 do
    {
	// Lancer la conversion de la voie 0
	CAN=0x0040;
	/*Attendre la fin de la conversion*/
	do{}while(Fin_Conv_AN==1);
	//Lire le rsultat de conversion
	resultat_conv=CAN;
	//masque des bits de poids faibles pour afficher les 4 bits de poids fort sur 7 Segments
	val_aff=(unsigned char) ((resultat_conv&0x0FFF)>>8);
	Port_C=Tab_Valeurs_7Seg[val_aff] ;  
    }while(1);
}
//Fin de la boucle principale

