/***************************************
*TEST SUR EID210 avec FEU  DE  CARREFOUR*
*************************
*    Test du FDC		*
*				*
***********************
************************/
	
/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Structures_Donnees.h" 
//#include "feux_carrefour.h"
void Active_Etat(int);
void Attendre(int);

/****************************************
*        FONCTION PRINCIPALE    	*
****************************************/
main()
{
int cpt=1;
/*  	INITIALISER
*************************/
/* Dfinition des "directions" du port C "   */

PortC_Dir=0x07;
PortC=0x00;

/*  Configurer le port A    en mode "Discet Input Output"   (DIO)-> code $8  */
CFSR3=0x8888;	/*  CHA0  CHA3 en mode "DIO" 	*/
CFSR2=0x8888;	/*  CHA4  CHA7 en mode "DIO"	*/
CFSR1=0x8888;	/*  CHA8  CHA11 en mode "DIO"	*/
CFSR0=0x8888;	/*  CHA12  CHA15 en mode "DIO"	*/
/* Dfinir les priorits */
CPR1=0xFFFF;	/* Tous les bits de PA en priorit haute  */
CPR0=0xFFFF;	/* Tous les bits de PB en priorit haute  */

/*  	 BOUCLE PRINCIPALE
************************************/
printf("Test du FEUX DE CARREFOUR EID002000\n");
for(cpt=1;cpt<9;cpt++)
{
	Active_Etat(cpt);		/*Autorisation des voies principales(feux 1 et 2 au vert)*/
}

printf("\n Fin du Test \n Test OK\n");

}    /*	Fin de la fonction principale
     ************************************/


/*fonction d'affectation des sorties sur port C
****************************************************/	

void Active_Etat(int j)		/*Affectation des registres de sorties du port C
                          en fonction de l'tat	des tapes*/								
{
	switch(j)	/* numro de l'tat */ 
	{
	case 1 : {	PortC=0x00;		
			printf("Gestion Voie Principale 1\n");
			HSRR0=0xAAAA;	//Port B
			HSRR1=0xAAA9;	//Port A 
			Attendre(2);
			HSRR0=0xAAAA;
			HSRR1=0xAAA6;
			Attendre(2);
			HSRR0=0xAAAA;	//Port B
			HSRR1=0xAA9A;	//Port A
			Attendre(2);
			break;
		   } 	

	case 2 : {	PortC=0x00;
			printf("Gestion Voie Degagement 1\n");
			HSRR0=0xAAAA;	//Port B
			HSRR1=0x9AAA;	//Port A
			Attendre(2);
			HSRR0=0xAAAA;
			HSRR1=0x6AAA;
			Attendre(2);
			HSRR0=0xAAA9;	//Port B
			HSRR1=0xAAAA;	//Port A
			Attendre(2);
			break;
		   } 	

	case 3 : {	PortC=0x00;		
			printf("Gestion Voie Principale 2\n");
			HSRR0=0xAAAA;
			HSRR1=0xAA6A;
			Attendre(2);
			HSRR0=0xAAAA;	//Port B
			HSRR1=0xA9AA;	//Port A
			Attendre(2);
			HSRR0=0xAAAA;
			HSRR1=0xA6AA;
			Attendre(2);
			break;
		   } 	

	case 4 : {	PortC=0x00;
			printf("Gestion Voie Degagement 2\n");
			HSRR0=0xAAA6;
			HSRR1=0xAAAA;
			Attendre(2);
			HSRR0=0xAA9A;	//Port B
			HSRR1=0xAAAA;	//Port A
			Attendre(2);
			HSRR0=0xAA6A;
			HSRR1=0xAAAA;
			Attendre(2);
			break;
		   } 	
	case 5 : {	PortC=0x00;
			printf("Gestion Voie Secondaire\n");
			HSRR0=0xA9AA;	//Port B
			HSRR1=0xAAAA;	//Port A
			PortC=0x0200;
			Attendre(2);
			HSRR0=0xA6AA;
			HSRR1=0xAAAA;
			Attendre(2);
			HSRR0=0x9AAA;	//Port B
			HSRR1=0xAAAA;	//Port A
			Attendre(2);
			break;
		   } 	
	case 6 : {	PortC=0x00;
			printf("Gestion Feux Pienton\n");
			HSRR0=0x6AAA;
			HSRR1=0xAAAA;
			Attendre(2);
			HSRR0=0xAAAA;
			PortC=0x01;		
			Attendre(2);
			PortC=0x02;
			Attendre(2);
			PortC=0x04;
			Attendre(2);
			break;
		   } 	

	case 7 : {	
			HSRR0=0xAAAA;
			HSRR1=0xAAAA;
			PortC=0x00;
			printf("Gestion Appel Piton\n");

			printf("Appuier sur les AP1 les un aprs les autres\n");
			printf("AP1_1/4??\n");
			while((Port_C&0x08)==0x08);
			Attendre(1);
			printf("AP1_1/4: OK\n");
			printf("AP1_2/4??\n");
			while((Port_C&0x08)==0x08);
			Attendre(1);
			printf("AP1_2/4: OK\n");
			Attendre(1);
			printf("AP1_3/4??\n");
			while((Port_C&0x08)==0x08);
			Attendre(1);
			printf("AP1_3/4: OK\n");
			printf("AP1_4/4??\n");
			while((Port_C&0x08)==0x08);
			Attendre(1);
			printf("AP1_4/4: OK\n");

			printf("Appuier sur les AP2 les un aprs les autres\n");
			printf("AP2_1/4??\n");
			while((Port_C&0x10)==0x10);
			Attendre(1);
			printf("AP2_1/4: OK\n");
			printf("AP2_2/4??\n");
			while((Port_C&0x10)==0x10);
			Attendre(1);
			printf("AP2_2/4: OK\n");
			Attendre(1);
			printf("AP2_3/4??\n");
			while((Port_C&0x10)==0x10);
			Attendre(1);
			printf("AP2_3/4: OK\n");
			printf("AP2_4/4??\n");
			while((Port_C&0x10)==0x10);
			Attendre(1);
			printf("AP2_4/4: OK\n");

			break;
		   } 	

	case 8 : {	
			printf("Gestion Presence Voiture\n");
			printf("D1??\n");
			while((Port_C&0x20)==0x20);
			printf("D1: OK\n");

			printf("D2??\n");
			while((Port_C&0x40)==0x40);
			printf("D2: OK\n");

			printf("D3_1/2??\n");
			while((Port_C&0x80)==0x80);
			printf("D3_1/2: OK\n");
			Attendre(4);
			printf("D3_2/2??\n");
			while((Port_C&0x80)==0x80);
			printf("D3_2/2: OK\n");
			
			break;
		   } 	



	default : 	{HSRR0=0xAAAA;HSRR1=0xAAAA;PortC=0x00;break;}  	// On teint tout 
	}
}

/*Boucle d'attente logicielle
*************************************/
void Attendre(int Duree) // Duree passe en paramtre
{	
int j,fin;
fin=Duree*250000;
for(j=0;j<=fin;j++); //boucle d'attente
}