/******************************************************
*	TP SUR LA CARTE EID005					*
*******************************************************
*	Ecrire un programme en C				*
*	qui ralise la lecture d'un touche			*
*	sur un clavier matric 4 x 4, en mode pooling	*
*	par dtection de l'activation d'une touche	*
*	Afficher la touche sur le moniteur			*
*******************************************************
*	Nom du FICHIER : TP3.c					*
*	**************						*	
******************************************************/

//	Inclusion des fichiers de dfinition

#include "eid210.h"
#include "eid005.h"

//============================
//   	FONCTION PRINCIPALE 
//============================


main ()
{ 
short    Touche[4][4] = { 0x0A, 0x00, 0x0B, 0x0F,
				  0x07, 0x08, 0x09, 0x0E,
				  0x04, 0x05, 0x06, 0x0D,
				  0x01, 0x02, 0x03, 0x0C } ;
short N, V, ValeurTouche; 
int tmp ;
int i, j, k;

// Prparation pour affichage sur LCD

init_aff();			// Initialisation de l'afficheur
lcd_cls();			// Effacement de l'afficheur
lcd_gotoxy(0x30,00);	// Dfinition de la position de dpart de la chane de caractres

//	Balyage des lignes du clavier en donnant successivement  la variable
//	clavier.matrice.ligne, les quartets  : 1110, 1101, 1011, 0111 .  

printf ("\n-------------------------\n");
printf ("TESTER TOUTES LES TOUCHES \n");
printf ("------------------------- \n\n");

j=0;
do
{j++;
 printf ("Appuyer sur une touche \n");
//	Touche appuye ?
//	Balayage ligne
while (!touche)			// Attente appui touche
{
	for (i = 0; i<4; i++ )
	{	
		clavier.matrice.ligne = ~(1 << i); // Toutes les colonnes  1 sauf la n i	
		tmp = i;
		if (touche == 1) break;			// touche = 1 ==> au moins une touche appuye	
	for (k = 0 ; k<10000 ; k++);		// temporisation
 	}
}
/*	Extraire le poids de la colonne :
	clavier.matrice.colonne = Elment colonne (4 bits) de la structure appartenant 
 	 la variable clavier de l'union reg_clavier. 
	Puis extraire la valeur de la touche appuye donne par le poids de la colonne :
 	Ce poids est donne par la variable : clavier.matrice.colonne & 0xF
*/
switch((~(clavier.matrice.colonne)) & 0x0F )
{
	case 1 : ValeurTouche= Touche [tmp][3]; break; 		//Colonne pods 1
	case 2 : ValeurTouche= Touche [tmp][2]; break; 		//Colonne pods 2 
	case 4 : ValeurTouche= Touche [tmp][1]; break;		//Colonne pods 4
	case 8 : ValeurTouche= Touche [tmp][0]; break;		//Colonne pods 8 	
}	

//	Afficher loa valeur de la touche  l'cran du PC
printf ("La touche appuyee est : %x\n\n", ValeurTouche );
while (touche)				// Attente relche touche
for (k = 0 ; k<10000 ; k++);	// Temporisation
}
//	Toutes les touches sont testes ?
while (j<16);
}

