
/******************************************************
*	TP SUR LA CARTE EID005					*
*******************************************************
*	Trac de lignes de : 					*
*	horizontale, verticale, oblique, de cercles ...	*
*									*
*******************************************************
*	Nom du FICHIER : TP5.c					*
*	**************						*	
******************************************************/

//	Inclusion des fichiers de dfinition

#include "eid005.h"
#include <math.h>

//============================
//   	FONCTION PRINCIPALE 
//============================

main()
{
double  pi = 3.14159265 ;
int i, N, m1, m2, k=28;	//	k : amplitiude maximale de sin(i*pi/N)

int PB = 0xF8 ;	//  	Plume baisse : allumer un pixel
int PL = 0xF0 ;	//	Plume leve : teindre le pixel	


init_aff();		//	Initialisation de l'afficheur
lcd_cls();		//	Effacement de l'afficheur
Tab_Sin_Cos ();	//	Calcul sinus et cosinus sur 360 par pas de 1
			//  	pour le tracer des cercles 

/******************************************************************************
*	Exemple : Trac d'un rectangle au contour de l'afficheur, de ces 		*
*	diagonales, et des deux axes de symttrie horizontale et verticale	*
******************************************************************************/

Tracer_LV(0,0,63,0,PB);
Tracer_LV(0,127,63,127,PB);
Tracer_LH(0,0,0,127,PB);
Tracer_LH(63,0,63,127,PB);

Droite(0,0,63,127,PB);
Droite(63,0,0,127,PB);
Cercle_NPoints(32,63,28,PB, 60);

delay (500000);
lcd_clear_Graph();			// Effacer graphique

Rectangle(10,20,40,60,PB);
Triangle(15,25,55,50,25,100,PB);
delay (500000);
lcd_clear_Graph();

// Tracer d'une sinusode par POINTS sur un oscilloscope en utilsant la fonction 
// void Tracer_Pixel(int x, int y, unsigned char Pen)

for (i=0; i<64; i +=8 )			// Grille 8 lignes horizontales
	Tracer_LH(i,0,i,127,PB);
	Tracer_LH(63,0,63,127,PB); 
for (i=0; i<127; i +=16 )		// Grille 8 lignes horizontales
	Tracer_LV(0,i,63,i,PB); 
	Tracer_LV(0,127,63,127,PB);
	
for(i=0; i<126; i++)

{
N = 40;
m1 = k*sin(i*(pi/N));
Tracer_Pixel(32-m1,i,PB);	// Tracer par POINTS
}

delay (500000);
lcd_clear_Graph();		// Effacer graphique


// Tracer d'une sinusode par SEGMENTS sur un oscilloscope en utilsant la fonction 
// void Droite ( int x1, int y1,  int x2, int y2, int  Pen )

for (i=0; i<64; i +=8 )			// Grille 8 lignes horizontales
	Tracer_LH(i,0,i,127,PB);
	Tracer_LH(63,0,63,127,PB); 
for (i=0; i<127; i +=16 )		// Grille 8 lignes horizontales
	Tracer_LV(0,i,63,i,PB); 
	Tracer_LV(0,127,63,127,PB);

for(i=0; i<126; i++)
	{
	m1 = k*sin(i*(pi/30));
	m2 =k*sin((i+1)*(pi/30));
	Droite(32-m1 , i,32-m2, i+1, PB);
}


}

//	Fin du programme
