/************************************************************
*	TP SUR LA CARTE EID005						*
*************************************************************
*	Runion des TP4 et TP5						*
*	Creer un tableau sur l'afficheur LCD			*
*	Detecter l'appuie sur une touche du clavier matric	*
*	Afficher cette touche dans la case du tableau		*
*************************************************************
*	Nom du FICHIER : TP5_1.c					*
*	**************							*	
*************************************************************/

//	Inclusion des fichiers de dfinition
#include "eid005.h"

//============================
//   	FONCTION PRINCIPALE 
//============================


main ()
{ 
//afficheur
int PB = 0xF8 ;	//  	Plume baisse : allumer un pixel
int PL = 0xF0 ;	//	Plume leve : teindre le pixel	
//Placer les touches sur le LCD
short    lcd_colonne[4]={0x02,0x05,0x08,0x0b};
short    lcd_ligne[4]={0x10,0x30,0x50,0x70};

//clavier
int tch_app=0x0000;	//savoir quelles touches ont t appuyes? msb=>F lsb=>0
short    Touche[4][4] = { 0x0A, 0x00, 0x0B, 0x0F,
				  0x07, 0x08, 0x09, 0x0E,
				  0x04, 0x05, 0x06, 0x0D,
				  0x01, 0x02, 0x03, 0x0C } ;
short V, ValeurTouche; 

int tmp ;
int i, j, k ;

// Prparation pour affichage sur LCD
init_aff();			// Initialisation de l'afficheur
lcd_cls();			// Effacement de l'afficheur
//Tracer un qadrillage sur l'afficheur pour les touches
Rectangle (5,10,63,105,PB);
Rectangle (5,35,63,80,PB);
Tracer_LV(5,57,63,60,PB);
Rectangle (20,10,50,105,PB);
Tracer_LH(35,10,50,105,PB);

// Balyage des lignes du clavier en donnant successivement  la variable
// clavier.matrice.ligne, les quartets  : 1110, 1101, 1011, 0111 .  
printf ("\n-------------------------\n");
printf ("TESTER TOUTES LES TOUCHES \n");
printf ("------------------------- \n\n");

j=0;
do
{j++;
printf ("Appuyer sur une touche \n"); 

//	Touche appuye ?
//	Balayage ligne

while ((clavier.matrice.colonne & 0x0F) == 0x0F)	// Attente appui touche
{
	for (i = 0; i<4; i++ )
	{	
		clavier.matrice.ligne = ~(1 << i); 	// Toutes les colonnes 
								//  1 sauf la n i	
		tmp = i;
		if (touche == 1) break;			// touche = 1 ==> au moins 
								// une touche appuye		
		for (k = 0 ; k<10000 ; k++);		// temporisation
 	}
}

switch((~(clavier.matrice.colonne)) & 0x0F )
{
	case 1 : ValeurTouche= Touche [tmp][3]; break; 		//Colonne pods 1
	case 2 : ValeurTouche= Touche [tmp][2]; break; 		//Colonne pods 2 
	case 4 : ValeurTouche= Touche [tmp][1]; break;		//Colonne pods 4
	case 8 : ValeurTouche= Touche [tmp][0]; break;		//Colonne pods 8 	
}	

//Affiche la touche appuye sur le LCD + memorisation des touches appuyes
switch(ValeurTouche) 
{
	case 0 :
		{
		lcd_gotoxy(lcd_ligne[3]|lcd_colonne[1],0);// affiche sur LCD
		lcd_out_str("0");					//la touche appuye
		tch_app|=0x0001;					// + memorisation
		break;
		}
	case 1 :
		{
		lcd_gotoxy(lcd_ligne[0]|lcd_colonne[0],0);
		lcd_out_str("1");						
		tch_app|=0x0002; 				
		break;
		}
	case 2 :
		{
		lcd_gotoxy(lcd_ligne[0]|lcd_colonne[1],0);
		lcd_out_str("2");
		tch_app|=0x0004;
		break;
		}
	case 3 :
		{
		lcd_gotoxy(lcd_ligne[0]|lcd_colonne[2],0);
		lcd_out_str("3");	
		tch_app|=0x0008;
		break;
		}
	case 4 :
		{
		lcd_gotoxy(lcd_ligne[1]|lcd_colonne[0],0);
		lcd_out_str("4");
		tch_app|=0x0010;
		break;
		}
	case 5 :
		{
		lcd_gotoxy(lcd_ligne[1]|lcd_colonne[1],0);
		lcd_out_str("5");
		tch_app|=0x0020;
		break;
		}
	case 6 :
		{
		lcd_gotoxy(lcd_ligne[1]|lcd_colonne[2],0);
		lcd_out_str("6");
		tch_app|=0x0040;
		break;
		}
	case 7 :
		{
		lcd_gotoxy(lcd_ligne[2]|lcd_colonne[0],0);
		lcd_out_str("7");
		tch_app|=0x0080;
		break;
		}
	case 8 :
		{
		lcd_gotoxy(lcd_ligne[2]|lcd_colonne[1],0);
		lcd_out_str("8");
		tch_app|=0x0100;
		break;
		}
	case 9 :
		{
		lcd_gotoxy(lcd_ligne[2]|lcd_colonne[2],0);
		lcd_out_str("9");
		tch_app|=0x0200;
		break;
		}
	case 0xa :
		{
		lcd_gotoxy(lcd_ligne[3]|lcd_colonne[0],0);
		lcd_out_str("A");
		tch_app|=0x0400;
		break;
		}
	case 0xb :
		{
		lcd_gotoxy(lcd_ligne[3]|lcd_colonne[2],0);
		lcd_out_str("B");
		tch_app|=0x0800;
		break;
		}
	case 0xc :
		{
		lcd_gotoxy(lcd_ligne[0]|lcd_colonne[3],0);
		lcd_out_str("C");	
		tch_app|=0x1000;
		break;
		}
	case 0xd :
		{
		lcd_gotoxy(lcd_ligne[1]|lcd_colonne[3],0);
		lcd_out_str("d");
		tch_app|=0x2000;
		break;
		}
	case 0xe :
		{
		lcd_gotoxy(lcd_ligne[2]|lcd_colonne[3],0);
		lcd_out_str("E");
		tch_app|=0x4000;
		break;
		}
	case 0xf :
		{
		lcd_gotoxy(lcd_ligne[3]|lcd_colonne[3],0);
		lcd_out_str("F");
		tch_app|=0x8000;
		break;
		}
}

// Afficher la valeur de la touche  l'cran du PC
printf ("La touche appuyee est : %x\n\n", ValeurTouche );

while (touche)			// Attente relche touche
for (k = 0 ; k<10000 ; k++);	// Temporisation 
	
}
while (tch_app!=0xFFFF);//	Toutes les touches sont testes ?
printf("toutes les touches sont testes \nFin du programme\n");
}



