/******************************************************************
*	TP SUR LA CARTE EID005							*
*******************************************************************
*	Permettre a l'utilisateur de mettre a jour			*
*	l'horloge temps rel							*
*	Si l'utilisateur a accepter, mettre a jour 			*
*	les paramettre de la RTC						*
*	Tracer (de maniere graphique) une horloge sur			*
*	l'afficheur LCD, avec le jour, la date et l'heure		*	
*	On souhaite un visualiser des secondes qui defilent sur l'afficheur	*
* 											*
*******************************************************************
*	Nom du FICHIER : TP6.c							*
*	**************								*	
******************************************************************/
#include "eid005.h"
#include <math.h>

/******************************/
/*	Fonctions Utilises	*/
/******************************/

int PL = 0xF0 ;			//	Plume Leve   ==> Effcer
int PB = 0xF8 ;			//    Plume Baisse ==> Tracer

main()
{
/******************************/
/* DECLARATION DES VARIABLES  */
/******************************/
char depart, x ;
int  R, hr, mn, sc, u, l, k ;
int jour, date, mois, an ;
int ahr, amn, asc ;
char * Jour ;
char * Mois ;
unsigned char stop ;

//	Saisie pour la mise  jour du RTC
unsigned char Annee[4] =  { 0x2, 0x0, 0x0, 0x0 } ;	// Affichage anne
unsigned char DMA [7];			// Saisie Date_Mois_Anne
unsigned char Date_Mois[5] ;		// Affichage Date et Mois
unsigned char Heure[6] ;		// Saisie et affichage
unsigned char Heure_Alarme[3] ;	// Saisie 	
unsigned char tmp; 

char * Jours[7] = {"Lundi", "Mardi", "Mercr", "Jeudi", "Vendr", "Samed", "Diman"};
char *_Mois[12]= {"Janv", "Fevr", "Mars", "Avri", "Mai", "Juin", "Juill", "Aot", 
                  "Sept", "Octo", "Nove", "Decem"};

/******************************/
/******************************/
/*					*/
/*	PROGRAMME PRINCIPAL	*/
/*					*/
/******************************/
/******************************/

// Clacul sinus cisinus 60 points : secondes

Tab_Sin_Cos ();	// Pour affichage des points Heures et secondes

// Initialisation afficheur

init_aff();
lcd_cls();

/******************************************/
/*	Saisie de l'heure ou lancer lecture */
/******************************************/
/* Permettre a l'utilisateur de mettre a jour l'horloge temps rel	*/
printf("    Taper : h pour mettre  l'heure \n    ou autre pour lancer \n");
depart=InRs232();
if (depart == 'h')
{
   	printf("    Entrer l'heure : hhmmss \n");	
	/* Taper :   
		hh = heures puis, 
		mm = minutes puis 
		ss = secondes.		
	*/
	for (u =0; u < 6; u++)
	{
	x=InRs232();
	if (x != 0x08)
		{	if ( u <0)
			u = 0;
			Heure[u] = x & 0x0F;
			printf("    \t\t%d \n",(x & 0x0F));
			printf ("                 Il reste encore %d   chiffre(s)\n", 5-u);
		}
	else
		{	u -= 2;		// Pour effacer les codes de Back Space et Entre
			printf ("\n  RECTIFICATION !\n");
		}
	}

/************************************************/
/*	Mise enforme hhmmss : Tableau Heuure[]	*/			 
/************************************************/

	Heure[0] = 10*Heure[0] + Heure[1] ;	// Heures
	Heure[1] = 10*Heure[2] + Heure[3] ;	// Minutes
	Heure[2] = 10*Heure[4] + Heure[5] ;	// Secondes

//	Verification de l'heure saisie
	printf ("    %d h %d mn %d s\t\n", Heure[0], Heure[1], Heure[2]);

/******************************/
/*	Saisie de la date		*/			 
/******************************/
printf ("    Entrer la date : jddmmaa \n");	
/* Taper :   
		j = jour (1=lundi, 2=mardi...), 
		dd = date,
		mm = mois puis 
		aa = anne (20aa). 
*/
for (u =0; u < 7; u++)
	{
	//scanf("%c",&x);
	x=InRs232();
	if (x != 0x08)
		{	if ( u <0)
			u = 0;
			DMA[u] = x & 0x0F;
			printf("    \t\t%d \n",(x & 0x0F));
			printf ("                 Il reste encore %d   chiffre(s)\n", 6-u);
		}
	else		
		{	u -= 2;		// Pour effacer les codes de Back Space et Entre
			printf ("\n  RECTIFICATION !\n");
		}
	}

/************************************************/
/*	Mise enforme jddmm : Tableau DMA[]		*/			 
/************************************************/
DMA [1] = 10*DMA [1] + DMA [2];	// Date
DMA [2] = 10*DMA [3] + DMA [4];	// Mois
DMA [3] = 10*DMA [5] + DMA [6];	// Anne


//	Verification de la date saisie
printf ("    %s %d %s 200%d  \n",Jours [DMA[0]-1],DMA[1], _Mois [DMA [2]-1],DMA [3]);


/************************************************/
/*	Programmation du circuit RTC : DS14285	*/			 
/************************************************/

//---	 Mettre  1 le bit 0 du registre de contrle du RTC : accs au RTC 

ctrl_rtc = 1 ;	

//--------	 Programmation des registres A et B
 
writebyte (REGB, 0x82);	// Rgeistre B = 1000 0010 
				// Autorisation de la mise mise  jour 
				// sans incrmentation des compteurs (sec, mm, h).
writebyte (REGA, 0x20);	// Registre A = 0010 0000 : 	

//--------	Mise  l'heure

writebyte (0, Heure[2]);
writebyte (2, Heure[1]);
writebyte (4, Heure[0]);

/*--------	Programmation de l'alarme

writebyte (1, Heure_Alarme [0]);
writebyte (3, Heure_Alarme [1]);
writebyte (5, Heure_Alarme [2]);
*/

//--------	Programmation de la Date

writebyte (6, DMA [0]);		// Jour de la semaine : 1 = lun, 2 = mar, ...	
writebyte (7, DMA [1]) ;	// Date dans le mois  
writebyte (8, DMA [2]);		// Mois dans l'anne
writebyte (9, DMA [3]) ;	// Anne
}
//information utilisateur
printf ("    EID005  RTC en route. Appuyer sur RESET pour le stoper \n");

/******************************/
/*	TRACE DE L'HORLOGE	*/			 
/******************************/

//-------	Tracer cercle heures	--------------------

for (u = 0; u <60; u += 5)
Cercle_H (32,63, 28, PB, u);	// Dessin de l'horloge

Rectangle(0,0,63,127,PB);	// Rectangle au tour de l'horloge


/******************************/
/*	Lancement de la RTC	*/			 
/******************************/

//------- Lancement RTC : incrmentaion des compteurs (sec, mm, h)
writebyte (REGB, 06);		
 
/************************************************/
/*	Lecture RTC et affichage de des donnes	*/			 
/************************************************/

do
{
	do
		tmp = readbyte(REGA);
	while ( tmp & 0x80);	// Attente UIP

//-----	Lecture de l'heure
	
sc = readbyte(0);
mn = readbyte(2); 
hr = readbyte(4);

//-----	Lecture jour, date, mois

jour = readbyte(6);
date = readbyte(7); 
mois = readbyte(8);
an   = readbyte(9);


//-----	Formatage et affichage Heur, minute, seconde

	Heure[0]= hr / 10 ;
	Heure[1]= hr % 10 ;
	Heure[2]= 0x0a ;		// Code ASCII dcal de l'Afficheur
	Heure[3]= mn / 10 ;
	Heure[4]= mn% 10 ;
	Heure[5]= 0x0a ;		// idem
	Heure[6]= sc / 10 ;
	Heure[7]= sc % 10 ;

lcd_gotoxy(0x55,0x0);
lcd_out_Tab(Heure, 5);			

//-----	Formatage et affichage Jour 

lcd_gotoxy(0x25,0x0);			
lcd_out_str(Jours[jour-1]);

//-----	Formatage et affichage Date et Mois

	Date_Mois[0]= date / 10 ;	// Dizaine Date
	Date_Mois[1]= date % 10 ;	// Unit date

//  Si affichage du mois en chiffre :
	Date_Mois[2]= 0xFF ;		// Code ASCII dcal de l'Afficheur - 0x10
	Date_Mois[3]= mois / 10 ;	// Dizaine mois
	Date_Mois[4]= mois % 10 ;	// Unit mois
	
lcd_gotoxy(0x34,0x0);
lcd_out_Tab(Date_Mois, 2);		

lcd_gotoxy(0x37,0x0);			
lcd_out_str(_Mois[mois-1]);


//-----	Formatage et Affichage Anne

Annee [2] = an / 10 ;	// Dizaine Anne
Annee [3] = an % 10 ;	// Unit Anne

lcd_gotoxy(0x46,0x0);			
lcd_out_Tab(Annee, 4);		

//-----	Lecture et Affichage des secondes

if (sc == 59)	// Effecer les secondes
{
	//Cercle_S (32,63, 28, PB, sc);
	for( u = 0; u<60; u++)
	Effacer_Cercle_S (32,63, 28, PL, u);
}
else
	Cercle_S (32,63, 28, PB, sc);
}
while (1);

}

//----	FIN DU PROGRAMME PRINCIPAL





