/*=======================================================================
 *     DEFINITIONS  POUR LA CARTE d'INTERFACE POUR SERVOMECANISME  EID060
 *=======================================================================
 


#define un 1
#define zero 2

/* Dfinitions particulires */
/*  TPU PARAMETER RAM */

//   Dfinition des tats des bits du port B 
#define Etat_TPU8	(*(union word_bits*) (0xFFFF82))   	/* PB0 sur maquette */ 
#define Etat_TPU9	(*(union word_bits*) (0xFFFF92))   	/* PB1 sur maquette */ 
#define Etat_TPU10	(*(union word_bits*) (0xFFFFA2))   	/* PB2 sur maquette */ 
#define Etat_TPU11	(*(union word_bits*) (0xFFFFB2))   	/* PB3 sur maquette */ 
#define Etat_TPU12	(*(union word_bits*) (0xFFFFC2))   	/* PB4 sur maquette */ 
#define Etat_TPU13	(*(union word_bits*) (0xFFFFD2))   	/* PB5 sur maquette */ 
#define Etat_TPU14	(*(union word_bits*) (0xFFFFE2))   	/* PB6 sur maquette */ 
#define Etat_TPU15	(*(union word_bits*) (0xFFFFF2))   	/* PB7 sur maquette */ 

#define PB0 Etat_TPU8.bit.b15			/*  Dernier Etat	 de l'entre PB0 */
#define PB1 Etat_TPU9.bit.b15			/*  Dernier Etat	 de l'entre PB2 */
#define PB2 Etat_TPU10.bit.b15			/*  Dernier Etat	 de l'entre PB3 */
#define PB3 Etat_TPU11.bit.b15			/*  Dernier Etat	 de l'entre PB4 */
#define PB4 Etat_TPU12.bit.b15			/*  Dernier Etat	 de l'entre PB5 */
#define PB5 Etat_TPU13.bit.b15			/*  Dernier Etat	 de l'entre PB6 */
#define PB6 Etat_TPU14.bit.b15			/*  Dernier Etat	 de l'entre PB7 */
#define PB7 Etat_TPU15.bit.b15			/*  Dernier Etat	 de l'entre PB8 */

// Pour le comptage des signaux en quadrature de phase issu du codeur accoupl  l'arbre moteur
 	/* PARAMETER RAM pour ch8 -> PB0 -> Cod_A  qui sera le canal primaire		*/
	#define CPTR_Pos_Mot *(signed short*)0xFFFF82
	#define Pos_Mot CPTR_Pos_Mot
	#define S_Pos_Mot CPTR_Pos_Mot
	#define Cor_PinS_CHA *(WORD*)0xFFFF88
	#define Edge_T_CHA *(WORD*)0xFFFF8A
	/* PARAMETER RAM pour ch9 -> PB1 ->  Cod_B qui sera le canal secondaire	*/
   	#define Cor_PinS_CHB *(WORD*)0xFFFF98
	#define Edge_T_CHB *(WORD*)0xFFFF9A

