/* startup pour EID210000

*/
	.title "CRT pour EID210+MTR"

/* These are predefined by new versions of GNU cpp.  */

.global	start
.global	exit

.global start_mtr
.global	cree
.global dort
.global	active

.global outrs232
.global inrs232
.global getch
.global clsscr
.global gotoxy
.global exe_sup
.global supprime
.global num_tache
.global m_send
.global mtr86exit
.global mtr86fatal
.global cvrtic
.global dsp_stk
.global	m_wait
.global m_signal
.global	e_cree
.global e_wait
.global e_signal
.global e_close
.global	p_open
.global p_read
.global p_write
.global p_close
.global s_cree
.global s_wait
.global s_signal
.global	s_close
.global detruit
.global r_cree
.global r_wait
.global r_signal
.global d_tic
.global tache_c
.global rv_cree
.global rv_signal
.global rv_close

.set _TRAP,14
.set _A5_NOYAU,0x810000

.set TRAP_MON,13
.set SCSR,0xFFFC0C
.set SCDR,0xFFFC0E

start:

	clr.l	%d0
	clr.l	%d1
	clr.l	%d2
	clr.l	%d3
	clr.l	%d4
	clr.l	%d5
	clr.l	%d6
	clr.l	%d7
	move.l	#__bss_start,%d1
	move.l	#_end,%d0
	cmp.l		%d0,%d1
	jbeq	start_3
	move.l	%d1,%a0
	sub.l		%d1,%d0
	sub.l		#1,%d0
start_2:
	clr.b	(%a0)+
	dbra	%d0, start_2

start_3:
	move.l		#0x8000b4,%a0
	move.l		#trap_mon,(%a0)
	move.l	#__stack_ss, %sp  /* pile superviseur */
	jsr		0xa000
	move.w	%sr,%d0
	bclr		#8,%d0
	bclr		#9,%d0
	bclr		#10,%d0
	bclr		#13,%d0
	move.w    %d0,%sr
	move.l	#__stack_us, %sp	/* pile utilisateur*/

	jsr	main

exit:
	moveq.l	#51,%d0
	bra	appel              /* retour au moniteur */

start_mtr: move.l	#_A5_NOYAU,0x800720   	/*  Donnees noyau*/
		moveq.l	#1,%d0			/* N de fonction (start)*/
		move.l	4(%sp),%a0		/* Adresse tache */
		move.l	8(%sp),%a1		/* Taille de la pile */
		move.l	#_HEAPSIZE,%d1		/* Taille du tas */
		movem.l	%a2-%a4,-(%sp)
		move.l	%a5,%a3			/* A5 de l'appli (si utilise) */
		lea.l	ftache,%a4		/* Adresse ftache (->SUPER) */
		trap	#_TRAP			/* Appel du noyau  */
		movem.l	(%sp)+,%a2-%a4
		rts

cree:   	moveq.l	#2,%d0
			bra	appel

detruit:	moveq.l	#3,%d0
			bra	appel

supprime:	moveq.l	#4,%d0
			bra	appel

num_tache:	moveq.l	#5,%d0
		bra	appel

active:		moveq.l	#6,%d0
			bra	appel

m_send:		moveq.l	#7,%d0
			bra	appel

mtr86exit:	moveq.l	#8,%d0
			bra	appel

dort:		moveq.l	#9,%d0
			bra	appel

reveille:	moveq.l	#10,%d0
			bra	appel

cvrtic:		moveq.l	#11,%d0
			bra	appel

d_tic:		moveq.l	#12,%d0
			bra	appel

dsp_stk:	moveq.l	#13,%d0
			bra	appel

com_open:	moveq.l	#14,%d0
			bra	appel

com_close:	moveq.l	#15,%d0
			bra	appel

com_read:	moveq.l	#16,%d0
			bra	appel

com_write:	moveq.l	#17,%d0
			bra	appel

fintache:	moveq.l	#18,%d0
			bra	appel

t_cree:		moveq.l	#19,%d0
			bra	appel

t_start:	moveq.l	#20,%d0
			bra	appel

t_stop:		moveq.l	#21,%d0
			bra	appel

r_cree:		moveq.l	#22,%d0
			bra	appel

r_close:	moveq.l	#23,%d0
			bra	appel

r_wait:		moveq.l	#24,%d0
			bra	appel

r_signal:	moveq.l	#25,%d0
			bra	appel

m_wait:		moveq.l	#26,%d0
			bra	appel

m_signal:	moveq.l	#27,%d0
			bra	appel

e_cree:		moveq.l	#28,%d0
			bra	appel

e_close:	moveq.l	#29,%d0
			bra	appel

e_wait:     movem.l %d2/%a2,-(%sp)
			moveq.l	#30,%d0
			move.l	12(%sp),%d1
			move.l	16(%sp),%a0
			move.l	20(%sp),%a1
			move.l	24(%sp),%d2
			move.l	28(%sp),%a2
			trap	#_TRAP
			movem.l	(%sp)+,%d2/%a2
			rts

e_signal:	moveq.l	#31,%d0
			bra	appel

p_open:		moveq.l	#32,%d0
			bra	appel

p_close:	moveq.l	#33,%d0
			bra	appel

p_read:		moveq.l	#34,%d0
			bra	appel

p_write:	moveq.l	#35,%d0
			bra	appel

p_plein:	moveq.l	#36,%d0
			bra	appel

p_vide:		moveq.l	#37,%d0
			bra	appel

rv_cree:	moveq.l	#38,%d0
			bra	appel

rv_close:	moveq.l	#39,%d0
			bra.s	appel

rv_signal:	moveq.l	#40,%d0
			bra.s	appel

s_cree:		moveq.l	#41,%d0
			bra.s	appel

s_close:	moveq.l	#42,%d0
			bra.s	appel

s_wait:		moveq.l	#43,%d0
			bra.s	appel

s_signal:	moveq.l	#44,%d0
			bra.s	appel

isr_cree:	moveq.l	#45,%d0
			bra.s	appel

isr_close:	moveq.l	#46,%d0
			bra.s	appel

mtr86status:	moveq.l	#47,%d0
			bra.s	appel

status_ascii:	moveq.l	#48,%d0
			bra.s	appel

mtr86fatal:	moveq.l	#49,%d0
			bra.s	appel

tache_c:		moveq.l	#50,%d0

appel:		move.l	4(%sp),%d1
			move.l	8(%sp),%a0
			move.l	0x0c(%sp),%a1
			trap	#_TRAP
			rts

ftache:		jmp	fintache

/* adaptation avec le noyau eid210 */


trap_mon:	movem.l	%a0-%a1,-(%sp)
		move.l		#tab_mon,%a0
		lsl.l		#2,%d0
		move.l		0(%a0,%d0),%a1
		jsr		(%a1)
		movem.l	(%sp)+,%a0-%a1
		rte

outrs232:	movem.l	%d3,-(%sp)
		move.l		8(%sp),%d3
		move.l		#0,%d0
		trap		#TRAP_MON
		movem.l	(%sp)+,%d3
		rts
getch:
inrs232:	move.l		#1,%d0
		trap		#TRAP_MON
		rts

clsscr:		movem.l	%d3,-(%sp)
		move.l		#2,%d0
		trap		#TRAP_MON
		movem.l	(%sp)+,%d3
		rts

gotoxy:	movem.l	%d1-%d3,-(%sp)
		move.l		16(%sp),%d1
		move.l		20(%sp),%d2
		add.b		#31,%d1
		add.b		#31,%d2
		move.l		#3,%d0
		trap		#TRAP_MON
		movem.l	(%sp)+,%d1-%d3
		rts

exe_sup:		movem.l	%a2,-(%sp)
		move.l	8(%sp),%a2
		move.l	#4,%d0
		trap	#TRAP_MON
		movem.l	(%sp)+,%a2
		rts

out_rs:		move.w	SCSR,%d0
		and.w		#0x0100,%d0
		beq.s		out_rs
		move.w	%d3,SCDR	
		rts
in_rs:		move.w	SCSR,%d0
		and.w		#0x0040,%d0
		beq.s		in_rs
		move.w	SCDR,%d0
		rts
cls:		move.b	#27,%d3
		jsr		out_rs
		move.b	#'H',%d3
		jsr		out_rs
		rts
gtxy:		move.b	#27,%d3
		jsr		out_rs
		move.b	#'Y',%d3
		jsr		out_rs
		move.b	%d2,%d3	/* d2=Y */
		jsr		out_rs
		move.b	%d1,%d3	/* d1=X */
		jsr		out_rs
		rts

e_sup:		jsr	(%a2)
		rts


tab_mon:	dc.l	out_rs
		dc.l	in_rs
		dc.l	cls
		dc.l	gtxy
		dc.l	e_sup
