
#include "mtr86.h"

EVENEMENT ev1,ev2;

TACHE  tacheA();                     /*     PROTOTYPES DES TACHES      */
TACHE  tacheB();                     /*     PROTOTYPES DES TACHES      */
TACHE  tacheC();
TACHE  tacheD();
TACHE  tacheE();
TACHE  tacheF();

_cputs(char *s)
{
   MONITOR
   printf(s);
   ENDM
}


TACHE tacheA()
{
   dsp_stk();
   ev1 = e_cree();
   ev2 = e_cree();
   cree(tacheB,2, 1024);
   cree(tacheD,2, 1024);
   cree(tacheC,1, 1024);
   cree(tacheE,1, 1024);
   cree(tacheF,2, 1024);
   active(num_tache(tacheC));
   active(num_tache(tacheB));
   active(num_tache(tacheD));
   active(num_tache(tacheE));
   active(num_tache(tacheF));
}

TACHE tacheB()
{
   _cputs("TacheB en attente\n");
   e_wait( ev1, 0x10, 0x10, EAND, 0);
   _cputs("Evenement 1 tacheB\n");
   if ( e_wait(ev1 ,0x1F, 0xFF, EAND, 100) == TIM )
       _cputs("Depassement du temps d'attente evenement dans tacheB\n");
   else
       _cputs("Evenement 2 tacheB\n");
   e_wait(ev1, 0x0F, 0X0F, EAND, 0);
   _cputs("Evenement 3 tacheB\n");
}

TACHE tacheD()
{
   _cputs("TacheD en attente\n");
   e_wait(ev1, 0x10, 0x10, EAND, 0);
   _cputs("Evenement 1 tacheD\r\n");
   if ( e_wait(ev1, 0x1f, 0xFF, EAND, 100) == TIM )
      _cputs("Depassement du temps d'attente evenement dans tacheD\n");
   else
      _cputs("Evenement 2 tacheD\n");
   e_wait(ev1, 0x0F, 0x0F, EAND, 0);
   _cputs("Evenement 3 tacheD\n");
}

TACHE tacheC()
{
   short i;
   for (i = 0; ; i++) {
       e_signal(ev1, i);
       e_signal(ev2, i);
       MONITOR
       printf("i = %2x\n",i);
       ENDM
       dort(cvrtic(200L));
   }
}

TACHE tacheE()
{
   _cputs("TacheE en attente\n");
    e_wait(ev2, 0x31, 0xFF, EAND, 0);
   _cputs("Evenement tache E\n");
   if ( e_signal(ev1, 0) == PAE ) {
      _cputs("\nPlus de taches en attente\r\n");
      _cputs("\nClos les evenements ce qui produira une erreur fatale dans la tache C\n");
      e_close( ev1 );
      e_close( ev2 );
      dort(150);
      mtr86exit(0);
   }
}

TACHE tacheF()
{
    _cputs("TacheF en attente\n");
    e_wait(ev1, 0x18, 0x18, EOR, 0);
    _cputs("Evenement 0x8  tache F\n");
    e_wait(ev1, 0x18, 0x18, EOR, 0);
    _cputs("Evenement 0x10 tache F\n");
    e_wait(ev1, 0x18, 0x18, EOR, 0);
    _cputs("Evenement 0x18 tache F\n");
}

/*
 ** M A I N
 */

main()
{
   printf("                Test des requetes de synchronisation par evenements\n\n");
   start_mtr(tacheA,512);
}