
#include "mtr86.h"


#define N   5

#define GAUCHE  ( (i+4) % N ) 
#define DROIT   ( (i+1) % N )
#define PENSER   0
#define AFFAMER  1
#define MANGER   2

char *p[3] = {"PENSE    \n","FIN      \n", "MANGE *\n"};

short  etat[N];

SEMAPHORE mutex;
SEMAPHORE s[N];

/*
 ** D I N E R   D E S   P H I L O S O P H E S
 */

TACHE  philosophe1();
TACHE  philosophe2();
TACHE  philosophe3();
TACHE  philosophe4();
TACHE  philosophe5();
TACHE  fin();


long rnd;

randinit(n)
long n;
{
  rnd=n;
}

long rand()
{
  return(rnd=(rnd+2563541)%544412563);
}

etat_philo(  )
{
  int j;
  gotoxy(1,16);
  for ( j = 0; j < 5; j++ ) {
      gotoxy(45, 10 + j);
      printf(p[etat[j]]);
  }
}

TACHE init()
{
  int j;
  gotoxy(30,3);
  printf("Diner des philosophes\n");
  mutex = s_cree(1);
  s[0]  = s_cree(0);
  s[1]  = s_cree(0);
  s[2]  = s_cree(0);
  s[3]  = s_cree(0);
  s[4]  = s_cree(0);

  active(cree(philosophe1, 5, 256));
  active(cree(philosophe2, 5, 256));
  active(cree(philosophe3, 5, 256));
  active(cree(philosophe4, 5, 256));
  active(cree(philosophe5, 5, 256));
  gotoxy(1,10);
  printf("                             philosophe 1 =\n");
  printf("                             philosophe 2 =\n");
  printf("                             philosophe 3 =\n");
  printf("                             philosophe 4 =\n");
  printf("                             philosophe 5 = \n");
  gotoxy(26,22);
  printf("Fin du repas dans 15 secondes !!!\n");
  for (;;) { // for (j=0;j<30;j++) {
    etat_philo();
    dort(cvrtic(500L));
  }
  gotoxy(1,24);
  mtr86exit(0);
}



 test(i)
 short i;
{
  if (etat[i%N]== AFFAMER && etat[GAUCHE] != MANGER && etat[DROIT] != MANGER) {
    etat[i%N] = MANGER;
    s_signal(s[i%N]);
  }
}

 pense(  )
{
  dort((rand() & 0x7F) + 10);
}

 mange(  )
{
  dort((rand() & 0x7F) + 10);
}

 prend_fourchette(i)
  short i ;
{
  s_wait(mutex,0);   /* Section critique */
  etat[i%N] = AFFAMER; /* PENSER -> AFFAME */
  test(i%N);         /* Voir si fourchette de gauche et de droite est libre*/
  s_signal(mutex);   /* Liberer section critique */
  s_wait(s[i%N],0 );   /* Bloquer les fourchettes  */
}

 pose_fourchette(i)
 short i;
{
  s_wait(mutex,0);   /* Section critique */
  etat[i%N] = PENSER;
  test( GAUCHE );
  test( DROIT  );
  s_signal(mutex);   /* Liberer section critique */
}


TACHE  philosophe1()
{
  while (1) {
    pense();
    prend_fourchette(1);
    mange();
    pose_fourchette(1);
  }
}

TACHE  philosophe2()
{
  while (1) {
    pense();
    prend_fourchette(2);
    mange();
    pose_fourchette(2);
  }
}

TACHE  philosophe3()
{
  while (1) {
    pense();
    prend_fourchette(3);
    mange();
    pose_fourchette(3);
  }
}

TACHE  philosophe4()
{
  while (1) {
    pense();
    prend_fourchette(4);
    mange();
    pose_fourchette(4);
  }
}

TACHE  philosophe5()
{
  while (1) {
    pense();
    prend_fourchette(5);
    mange();
    pose_fourchette(5);
  }
}


main()
{
  int  j;
  clsscr();
  gotoxy(10,1);
  printf("Resolution du probleme du diner des philosophes [Dijkstra 65]\n");
  start(init,1024);
  for (j=0; j< 5; j++ ) s_close( s[j] );
}
