// Pipe.c
#include <stdio.h>
#include "mtr86.h"

TUBE p1;
unsigned hCons, hProd;


TACHE Producteur(void)
{
  for (int j=0; j < 256; j++) 
    p_write( p1, &j, sizeof(j) );
}

TACHE Consommateur(void)
{
  int donnee;

  for (;;) {
    if ( p_read(p1, &donnee, sizeof(donnee)) == TIM ) 
      break;                // plus de donnes
    cprintf("  %03d\n", donnee);
  }
  p_close(p1);
  mtr86exit(0);
}

TACHE init(void)
{
   hCons = cree(Consommateur, 2, 1024);
   hProd = cree(Producteur,   2, 512);
   p1 = p_open(hProd, hCons, cvrtic(1000)); // timeout 1s sur les oprations 
   active(hCons);
   active(hProd);
}

main()
{
  clrscr();
  start_mtr(init, 512));
}
