// ProdConsS.c
#include "mtr86.h"
#define P(s) s_wait  (s,1000)
#define V(s) s_signal(s)

unsigned donnee;
SEMAPHORE sProd, sCons;


TACHE Producteur(void)
{
  int j;
  for (j=0; j < 100; j++) {
    P(sProd);
    donnee = j;
    V(sCons);
  }
}


TACHE Consommateur(void)
{
  for (;;) {
    if ( P(sCons) == TIM ) 
      break;                // plus de donnes
    cprintf("%03d\n", donnee);
    V(sProd);
  }
  s_close(sProd); s_close(sCons);
  mtr86exit(0);
}

TACHE init(void)
{
   sProd = s_cree(1);
   sCons = s_cree(0);

   active(cree(Producteur,   1, 256));
   active(cree(Consommateur, 1, 1024));
}

main()
{
  clrscr();
  start_mtr(init, 512);
}
