// babouins1.c
#include "mtr86.h"

#define P(s)  s_wait(s, 0)
#define V(s)  s_signal(s)
#define MAX 10  // Nombre de babouins arrivant simultanment

SEMAPHORE Sem;

void entrer_S(void)
{
  P(Sem);
  printf("->ES\n"); 
}

void entrer_N(void)
{
  P(Sem);
  printf("->EN\n"); 
}          

void sortir_N(void)
{
  V(Sem);
  printf("SN->\n"); 
}

void sortir_S(void)
{
  V(Sem);
  printf("SS->\n"); 
}

TACHE babouinN(void)
{
  entrer_N();
  dort(100);
  sortir_S();
}

TACHE babouinS(void)
{
  entrer_S();
  dort(100);
  sortir_N();
}

TACHE init(void)
{
  int i;
  Sem = s_cree(1);
  cree(babouinN, 2, 1024);
  cree(babouinS, 2, 512);
  for (i=0; i< MAX; i++) active(num_tache(babouinN));
  for (i=0; i< MAX; i++) active(num_tache(babouinS));
}

main()
{
  cputs("Resolution du probleme des babouins\n");
  InitSimulateur();
  start_mtr(init,512);
}
