// ev1.c
#include <stdio.h>
#include "mtr86.h"

EVENEMENT e1; 
unsigned char valeur;

TACHE evn_raz(void)
{
 for (;;)
 {    
   e_wait(e1, 0x00, 0x80, EAND, 0);
   valeur=0;
   EcritPortA(valeur);
 }
}


TACHE evn_bit_1(void)
{
 for (;;)
 {    
   e_wait(e1, 1, 1, EAND, 0);
   valeur|=1;
   EcritPortA(valeur);
 }
}

TACHE evn_bit_2(void)
{
 for (;;)
 {    
   e_wait(e1, 2, 2, EAND, 0);
   valeur|=2;
   EcritPortA(valeur);
 }
}

TACHE evn_bit_1_et_2(void)
{
 for (;;)
 {    
   e_wait(e1, 3, 3, EAND, 0);
   valeur|=4;
   EcritPortA(valeur);
 }
}

TACHE evn_bit_1_ou_2(void)
{
 for (;;)
 {    
   e_wait(e1, 3, 3, EOR, 0);
   valeur|=8;
   EcritPortA(valeur);
 }
}

TACHE acquisition(void)
{
  for (;;)
  {
    e_signal(e1, LirePortB());
    dort(10); 
   }
}
 

TACHE init(void)
{
  e1 = e_cree();
  active(cree(evn_bit_1, 2, 512));
  active(cree(evn_bit_2, 2, 512));
  active(cree(evn_bit_1_et_2, 2, 512));
  active(cree(evn_bit_1_ou_2, 2, 512));
  active(cree(evn_raz, 2, 512));
  active(cree(acquisition, 1, 512));
}

main()
{
  cputs("Exemple evenements\n");
  InitSimulateur();
  start_mtr(init,512);
}

