	/************************************************************************************ 
	*  		TP SUR CARTE EID210 SEULE          	     	                              *
	*************************************************************************************
	*      Tester les 3 LEDs connecte sur le port "QS" et l'entre "CTRL"                *
	* 									    	       *
	*                                             					  	                   *
	*  Cahier des charges: 							       *
	*  **********************							       *
	*  Le programme teste les 3 sorties utiles DIO du port QS        	                   *
	*  A chaque appui sur le "switch" CTRL il y a permutation  de l'tat des leds     *
	*                                                                                     "D12 D11 D10"                *
	*                                                                                                                             *
	*  Nom du fichier source en "c" : 	T_portQS.C                                                 *
	* *********************************
	*************************************************************************************/

/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Structures_donnees.h"
#include <stdio.h>

/* Dclaration des variables*/
 
/*=====================*/
/* Fonction principale */
/*=====================*/
main()
{
/* Dclarations *
*****************/
BYTE e_portqs;		/* Variable sur 8 bits donnant l'tat du port QS donc des LEDs */
e_portqs=0x10;
/*   Initialisations *
*********************/
e_portqs=0x10;
PQSCTR=0x0070;		/* Les 3 sorties sur lesquelles sont connectes les leds*/ 
				/* seront des sorties PQS(6..3) */
PORTQS=e_portqs;  		/* ecriture initiale */
/* On crit un message sur le moniteur */
printf("Test du port QS\n");
printf("Appuyer sur la touche CTRL pour faire une rotation\n");

/* Boucle principale *
**********************/    
	do
	{
	  printf("portqs=%2.2x\n",e_portqs);	/*  Visualiser  l'tat du port QS sur le moniteur 	*/
	  e_portqs<<=1;		    	/*  Prparation etats futurs				*/
	  if (e_portqs==0x80)	e_portqs=0x10;
	  while(S_Controle==1);		/*  Attente appui sur touche CTRL 			*/
	  PORTQS=e_portqs;			/*  Chargement nouvelle valeur sur LEDS 		*/
	  while(S_Controle==0);		/*  Attente relachement de la touche CTRL 		*/
    	}while(1);  				/*  Fin de la boucle principale */

} /* Fin de la fonction principale */

 
