	/*************************************************************************
	* 		TP SUR EID210 seul					*
	*************************************************************************
	*	ENVOYER UN CARACTERE SUR LE PORT			*
	*	DE COMMUNICATION SERIE                   			* 			
	*									*
	*  Cahier des charges:						*
	* ***********************						*
	*  A chaque appui sur la touche repre "CTRL" situe sur la	*
	*   carte EID210, il y a envoi d'un caratre qui doit apparatre	*
	*  sur l'cran de l'ardinateur						*
	* 									*
	*  NOM du FICHIER:  T_SERIE1.C				       	*
	* ********************							*
	*************************************************************************/

/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Structures_Donnees.h"
#include <stdio.h>

/*=======================*/
/* 	Fonction principale      */
/*=======================*/
main()
{
/* Dclarations *
*****************/
char caractere=0x30;	/* Ce sera le caratre '0'  */

/* Initialisations  */
SCCR0 = 9;		// Pour la vitesse de transmission de 57600 bauds
SCCR1 = 0x000C;	// Pour valider l'mission et la rception

/* Boucle principale *
**********************/    
	do
	{
	  while(S_Controle==1);		/*  Attente appui sur touche CTRL 			*/
	  while(S_Controle==0);		/*  Attente relachement de la touche CTRL 		*/
	  while(!(SCSR&TDRE));		/* Attendre liaison srie libre				*/
	   SCDR=caractere;				/*  Envoyer  le caractre sur la liaison srie RS232 	*/
    	}while(1);  				/*  Fin de la boucle principale */

} /* Fin de la fonction principale */

 

