	/************************************************************************
	* 	TP SUR EID210 seul						*
	*************************************************************************
	*         ECRITURE OU LECTURE A UNE ADRESSE MEMOIRE	* 			
	*								      	*	
	*  Cahier des charges:					      	*
	************************					      	*
	*  - Au lancement du programme, il y a envoi d'un message		* 
	*  - Format d'une demande d'criture  une adresse spcifie:	*
	*	Eaaaaaa=??       o   aaaaaa -> adresse en Hexadcimal	*
	*                                             ?? -> la valeur  crire en Hexa	*			
	*  - Format d'une demande de lecture  une adresse spcifie:	*
	*	Laaaaaa           o   aaaaaa -> adresse en Hexadcimal	*
	*  - La rponse est      (aaaaaa) = ??					*
	*									*
	*  NOM du FICHIER:  T_SERIE4.C				       	*
	**********************							*
	*************************************************************************/
/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Structures_donnees.h"
#include <stdio.h>

//  Dclaration des prototypes des fonctions
char Acquerir_info(char);  	// Paramtre pass, le nombre de caractres Hexa  acqurir
				// Paramtre renvoy le nombre d'erreurs dtectes lors de l'acquisition

// Dclaration des variables globales
unsigned int info_acquise;	
char caractere;

/*=====================*/
/*       Fonction principale    */
/*=====================*/
main()
{
/* Dclarations locales  la fonction main *
**********************************************/
char Mes_entree[]=" FORMAT:      Tappez    E       pour une Ecrire"
		       "\n              Tappez    L       pour une Lire     ";
char Mes_rep_Lec[]=" LECTURE:  Entrez une adresse  (sur 6 caracteres HEXA)          ";
char Mes_rep_Ecr1[]=" ECRITURE:  Entrez une adresse  (sur 6 caracteres HEXA)        ";
char Mes_rep_Ecr2[]=" ECRITURE:  Entrez la donnee  (sur 4 caracteres HEXA)        ";

char Mes_erreur[]=" CARACTERE non valide  !    IL  FAUT  RECOMMENCER !! ";
char erreur;
unsigned int AD_HEXA;		  	// Pour mmoriser une adresse en hexadcimal
unsigned short DATA_HEXA,*pointeur;	// Pour mmoriser une donne en hexadcimal


/* Initialisations  */
/* Boucle principale *
**********************/    
	do
	{ 
	printf("%s\n",Mes_entree);
	caractere=InRs232();					// Attendre qu'un caractre soit tapp puis le rcuprer
	if (caractere=='E'||caractere=='e')
		{  //   C'est pour crire  une adresse spcifie
		   //----------------------------------------------------------------------
		   printf("%s\n",Mes_rep_Ecr1);
		   erreur=Acquerir_info(6);		// On attend les 6 caractres de l'adresse
		  if(erreur==0)	
       		  	{ AD_HEXA=info_acquise;
			  printf("Vous voulez ecrire  l'adresse: %x\n",AD_HEXA);
			  printf("%s\n",Mes_rep_Ecr2);
			  erreur=Acquerir_info(4);		// On attend les 4 caractres de la donne
		  	  if(erreur==0)	
				{ DATA_HEXA=(short)info_acquise;
				  printf(" C'est OK  On ecrit la donnee : %4.4x  \n",DATA_HEXA);
			  	  pointeur=(short *)AD_HEXA;
			  	  *pointeur=DATA_HEXA;
		  		}
			 else printf("%s\n",Mes_erreur);
			}
		  else printf("%s\n",Mes_erreur);
		} // FIN d'criture  une adresse spcifie

	else if(caractere=='L'||caractere=='l')
		{  //   C'est pour lire  une adresse spcifie
		   //-------------------------------------------------------------------
		  printf("%s\n",Mes_rep_Lec);
		   erreur=Acquerir_info(6);		// On attend les 6 caractres de l'adresse
		  if(erreur==0)	
       		  	{  printf("Vous voulez lire  l'adresse:   %x\n",AD_HEXA);
			   AD_HEXA=info_acquise;
			  pointeur=(short *)AD_HEXA;
	  		  DATA_HEXA=*pointeur;
			  printf("La donnee lue  l'adresse specifiee est :   %4.4x\n",DATA_HEXA);
  	  		}
		 else printf("%s\n",Mes_erreur);
		}
	else printf("%s\n",Mes_erreur);
	 // FIN de lecture  une adresse spcifie
    	}while(1);  			/*  Fin de la boucle principale */
} /* Fin de la fonction principale */
  //=========================


//  FONCTION D'acquisition d'une information (adresse ou donne en HEXA  partir du clavier)
//============================================================================

char Acquerir_info(char nb)	// Paramtre pass, le nombre de caractres Hexa  acqurir
				// Paramtre renvoy le nombre d'erreurs dtectes lors de l'acquisition
{
// Dclaration des variables locales
char Num,nb_erreur;	// Pour mmoriser le numro du caractre reu
unsigned int temp;
//  Lers instructions
nb_erreur=0;
info_acquise=0;
	  // Boucle pour acqurir le nombre de caractres HEXA de l'adresse	
	  for(Num=nb;Num>=1;Num--)		
		{caractere=InRs232();			// Attendre qu'un caractre soit tapp puis le rcuprer
		  if((caractere>=0x30)&&(caractere<=0x39))	// Test si c'est un chiffre
			{ temp=caractere&0x00000F,temp=temp<<((Num-1)*4);
			  info_acquise=info_acquise|temp;	// Ranger dans l'adresse,  la bonne place
			}
		  else if((caractere>=0x41)&&(caractere<=0x46))  // Test si c'est une lettre HEXA (entre A et F)
		      	{ temp=caractere&0x00000F,temp=temp+0x09,temp=temp<<((Num-1)*4);
			  info_acquise=info_acquise|temp; 	// Ranger dans l'adresse,  la bonne place
			}
		   else 	// Le caractre tapp n'est pas correcte
 			{nb_erreur++;
			break;} 	// Ce n'est pas un caratre HEXA, donc on sort
		};  // Fin de la boucle de rcupration de l'adresse
return nb_erreur;
} // FIN fonction d'acquisition d'une info  partir du clavier
  //==============================================

//  FIN du fichier