/***************************************************************************
 * Module:        CPU_REG.H						   						   *
 * Date:         Aout 2001			 		                               *
 * Auteurs:      T. HANS  J.L. Rohou       			                       *
 * Description:   Declaration des registres du CPU 68332                   *
 ***************************************************************************/
#ifndef _CPU_H
#define _CPU_H
/*****************************
 *     SIM DU 688332         *
 * Registres generaux du CPU *
/*****************************/
 		#define VBR 	*(WORD*)	0x000000		/* Vector Base Register Vecteur de base 5-6*/
		/* registre de configuration du system integration module */
		#define Simcr	*(WORD*)	0xFFFA00		/* regitre de controle de la configuration du SIM */
		#define Syncr	*(WORD*)	0xFFFA04		/* registre de controle de l'horloge p */
		#define Sypcr	*(WORD*)	0xFFFA21		/* registre de controle du systeme de protection */
		#define Picr	*(WORD*)	0xFFFA22		/* registre de controle des interruptions */
		#define Pitr	*(WORD*)	0xFFFA24		/* registre de controle du timer d'interruption */
		#define Rsr		*(WORD*)	0xFFFA07		/* reset register */
		/* registre de configuration des chip selects */
		#define	Cspar0	*(WORD*)	0xFFFA44		/* reg. de contr. de la config du CSboot et des chip selects CS0  CS5 */
		#define	Cspar1	*(WORD*)	0xFFFA46		/* regitre de controle de la configuration des chips selects CS6  CS10 */
		#define	Csbarbt	*(WORD*)	0xFFFA48		/* regitre de configuration de l'adresse de base du chip select BOOT */
		#define	Csorbt	*(WORD*)	0xFFFA4A		/* regitre de controle des options de configuration du chip select BOOT */
		#define	Csbar0	*(WORD*)	0xFFFA4C		/* regitre de configuration de l'adresse de base du chip select CS0 */
		#define	Csor0	*(WORD*)	0xFFFA4E		/* regitre de controle des options de configuration du chip select CS0 */
		#define	Csbar1	*(WORD*)	0xFFFA50		/* regitre de configuration de l'adresse de base du chip select CS1 */
		#define	Csor1	*(WORD*)	0xFFFA52		/* regitre de controle des options de configuration du chip select CS1 */
		#define	Csbar2	*(WORD*)	0xFFFA54		/* regitre de configuration de l'adresse de base du chip select CS2 */
		#define	Csor2	*(WORD*)	0xFFFA56		/* regitre de controle des options de configuration du chip select CS2 */
		#define	Csbar3	*(WORD*)	0xFFFA58		/* regitre de configuration de l'adresse de base du chip select CS3 */
		#define	Csor3	*(WORD*)	0xFFFA5A		/* regitre de controle des options de configuration du chip select CS3 */
		#define	Csbar4	*(WORD*)	0xFFFA5C		/* regitre de configuration de l'adresse de base du chip select CS4 */
		#define	Csor4	*(WORD*)	0xFFFA5E		/* regitre de controle des options de configuration du chip select CS4 */
		#define	Csbar5	*(WORD*)	0xFFFA60		/* regitre de configuration de l'adresse de base du chip select CS5 */
		#define	Csor5	*(WORD*)	0xFFFA62		/* regitre de controle des options de configuration du chip select CS5 */
		#define	Csbar6	*(WORD*)	0xFFFA64		/* regitre de configuration de l'adresse de base du chip select CS6 */
		#define	Csor6	*(WORD*)	0xFFFA66		/* regitre de controle des options de configuration du chip select CS6 */
		#define	Csbar7	*(WORD*)	0xFFFA68		/* regitre de configuration de l'adresse de base du chip select CS7 */
		#define	Csor7	*(WORD*)	0xFFFA6A		/* regitre de controle des options de configuration du chip select CS7 */
		#define	Csbar8	*(WORD*)	0xFFFA6C		/* regitre de configuration de l'adresse de base du chip select CS8 */
		#define	Csor8	*(WORD*)	0xFFFA6E		/* regitre de controle des options de configuration du chip select CS8 */
		#define	Csbar9	*(WORD*)	0xFFFA70		/* regitre de configuration de l'adresse de base du chip select CS9 */
		#define	Csor9	*(WORD*)	0xFFFA72		/* regitre de controle des options de configuration du chip select CS9 */
		#define	Csbar10	*(WORD*)	0xFFFA74		/* regitre de configuration de l'adresse de base du chip select CS10 */
		#define	Csor10	*(WORD*)	0xFFFA76		/* regitre de controle des options de configuration du chip select CS10 */
 #endif
