/*********************************************************************** 
*  Programme de test des fonctions lmentaires de la carte SMD_332    *
*															           *
*      		V1.0   du 07/01	 T. HANS   J.L. ROHOU 		               *
* 	Nom du fichier: T_portQS.C									   	   *
*                                             						   *
 *  Description: 													   *
*  le programme teste les 3 sorties utiles DIO du port QS        	   *
*  A chaque appui sur le "switch" CTRL il y a permutation              *
*  sur les leds  "D12 D11 D10               		   				   *
************************************************************************/

/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "SMD_332.h"
#include "qsm.h"

#include <stdio.h>

/* Dclaration des variables*/
 

/*=====================*/
/* Fonction principale */
/*=====================*/
main()
{
BYTE e_portqs;
int carac;
printf("Test du port QS\n");
printf("Appuyer sur la touche CTRL pour faire une rotation\n");
e_portqs=0x10;
/*   Initialisations */
PQSCTR=0x0070;	/* Les 3 sorties sur lesquelles sont connectes les leds*/ 
				/* (seront des sorties PQS(6..3) */
PORTQS=e_portqs;  /* ecriture initiale */

/* Boucle principale */    
	do
	{
	printf("portqs=%2.2x\n",e_portqs);
	e_portqs<<=1;		    /*  Prparation etats futurs				*/
	if (e_portqs==0x80)
		e_portqs=0x10;
	while(S_Controle==1);	/* Attente appui sur touche CTRL 		*/
	PORTQS=e_portqs;		/* Chargement nouvelle valeur sur LEDS 		*/
	while(S_Controle==0);	/* Attente relachement de la touche CTRL */
    }while(1);
	
/* fin de la boucle principale */

} /* fin fonction principale */

 
