/***************************************************************************
 * Module:        QSM.H						   					      	   *
 * Date:         Aout 2001			 		                               *
 * Auteurs:      T. HANS  J.L. Rohou       			                       *
 * Description:   Declaration des registres de Queued Serial Module        *
 ***************************************************************************/
#ifndef	_QSM_H
#define _QSM_H

#define WORD short

#define QSMCR  *(WORD*)		0xFFFC00
#define QILVR  *(WORD*)		0xFFFC04
#define SCCR0  *(WORD*)		0xFFFC08
#define SCCR1  *(WORD*)		0xFFFC0A
#define SCSR   *(WORD*)		0xFFFC0C
#define SCDR   *(WORD*)		0xFFFC0E				

#define PORTQS *(WORD*)		0xFFFC14
#define PQSCTR *(WORD*)		0xFFFC16   /* PQSPAR-DDRQS */


#define TDRE   (WORD)	0x0100
#define RDRF   (WORD)	0x0040
#define RAF	   (WORD)	0x0020
		

#endif